;                                 MEGA-MON!
;                                 =========
;
;                         The ultimate 8085 monitor!
;
; MEGA-MON written by Khorton 
; V1.00  Copyright by the authour- all rights reserved!
; Permission to distribute this is granted for non-profit uses.
; See the .DOC file if you want to use it in you product.
; You may modify the source anyway you want, but if you use any
; part of it, please give me credit.

 
 .org h'0000

 .equ stack,h'e200                  ; Stack position
 .equ base,h'8000                   ; Base address for the interrupts
 .equ mem_strt,h'e201    ;ffc8               ; Start of memory

prog_strt:   jmp startit2  ;00      ; JMP to the start of the monitor
             nop           ;03      ; Interrupt relocation table
             nop           ;04
             nop           ;05
             nop           ;06
             nop           ;07
             jmp base+h'08 ;08
             nop           ;0b
             nop           ;0c
             nop           ;0d
             nop           ;0e
             nop           ;0f
             jmp base+h'10 ;10
             nop           ;13
             nop           ;14
             nop           ;15
             nop           ;16
             nop           ;17
             jmp base+h'18 ;18
             nop           ;1b
             nop           ;1c
             nop           ;1d
             nop           ;1e
             nop           ;1f
             jmp base+h'20 ;20
             nop           ;23
             nop           ;24
             nop           ;25
             nop           ;26
             nop           ;27
             jmp base+h'28 ;28
             nop           ;2b
             jmp base+h'2c ;2c
             nop           ;2f
             jmp base+h'30 ;30
             nop           ;33
             jmp base+h'34 ;34
             nop           ;37
             jmp base+h'38 ;38
             nop           ;3b
             jmp base+h'3c ;3c      ; End of interrupt relocation table
             nop

             .org h'0066
             
             jmp base+h'66  ;NMI


; 'Official' start of the monitor

startit2:    lxi h,stack-h'20           ; Set user SP to ff00
             shld reg_sp            ; Store it
         ;    mvi a,b'00000001
         ;    out h'0                ; set length, s-bits, brk, 8085 & 1Khz
         ;    mvi a,b'00000011       ; 19.2Kbaud, no par, /5
         ;    out h'1
         ;    mvi a,b'11000000       ; set breaks, interrupts
         ;    out h'2
;8256    ;    mvi a,b'00000011       ; set counter modes; p2 as output
         ;    out h'3
         ;    mvi a,b'11111111       ; set p1 as output
         ;    out h'4 
         ;    mvi a,b'11111111       ; disable all interrupts
         ;    out h'6
             

         ;    mvi a,b'01001110  ;N81, 16* baud rate
         ;    out h'04
         ;    nop
;8051    ;    nop
         ;    nop
         ;    mvi a,b'00010101
         ;    out h'04

             
             
;2681 
             
             lxi h,h'1000
             
ww:          mvi a,h'20
             
ww2:         dcr a
             jnz ww2
             dcx h
             mov a,h
             ora l
             jnz ww

             mvi a,b'00010011
             out h'00
             mvi a,b'00000111
             out h'00
             mvi a,b'11001100
             out h'01
             mvi a,b'01000101
             out h'02
             mvi a,b'10110000
             out h'04
             mvi a,b'00000000  ;set up chan 1
             out h'05
             
             mvi a,b'00010011
             out h'08
             mvi a,b'00000111
             out h'08
             mvi a,b'11001100
             out h'09
             mvi a,b'01000101  ;set up chan 2
             out h'0a
             
             mvi a,b'00000000
             out h'0d
             mvi a,b'10101010
             out h'0e
             cma
             out h'0f
             mvi a,b'00000000
             out h'40

             lxi h,h'8000           ; Set user PC to
             shld reg_pc            ; C000.
             xra a                  ; Clr acc.
             lxi h,reg_psw          ; Point to 1st reg
             mvi b,8                ; Number of regs=8
             
clr_rgs:     mov m,a                ; Set reg to 0
             inx h                  ; Inc pointer
             dcr b                  ; Dec # of regs
             jnz clr_rgs            ; Keep doing it
             
             inr a                  ; Set the mode to 1
             sta ss_mode            ; Store it
             lxi sp,stack           ; Initalize the SP
             lxi h,ms_hello         ; Show the welcome message
             call dcomp             ; Decomp it & show it
             
loop:        mvi b,'>'              ; Show a '>'
             call put_byte          ;  as a prompt.
             call get_usr           ; Get user's input
             
; This section interpets the instruction
; retrieved from the user.
             
             xra a                  ; Is the # of bytes in the buffer
             cmp b                  ; =0? ;i.e. the user just pressed
             jz loop                ; enter.  If so, get another entry.
             lda buffer             ; Get 1st char of buffer
             lxi h,ins_tabl         ; Point to instructions
             mvi c,h'fe             ; Set pointer to -2

wherloop:    inr c                  ; Inc pointer
             inr c                  ; twice.
             cmp m                  ; Compare it to the buffer
             jz hit                 ; If the same, do more comparing
             inx h                  ; Inc table addr
             inx h                  ; twice.
             mov b,a                ; Save the comapred-to character
             mov a,c                ; Are we at the end
             cpi 32*2               ; of the table?
             mov a,b                ; Un-save the reg
             jnz wherloop           ; If not, try again
             
ugh_oh:      lxi h,ms_you           ; Otherwise, show user
             call dcomp             ; that he entered something wrong
             jmp loop               ; and get another entry.

hit:         lda buffer+1           ; We got the 1st char, try for # 2
             inx h                  ; Inc table pointer
             cmp m                  ; If that's it, we're done
             jz found               ; Goto found, if we found it
             lda buffer             ; We didn't find it. Restore the
             inx h                  ; original buffer char, but point to
             jmp wherloop           ; the next entry and try again.

found:       mvi b,0                ; Set b=0 so we can adjust the addr tabl
             lxi h,whertabl         ; Point to table
             dad b                  ; Adjust pointer
             mov d,m                ; Get high-order byte
             inx h                  ; Inc pointer
             mov e,m                ; Get low-order byte
             lxi h,buffer           ; Point to buffer again
             mvi c,21               ; # of bytes in buffer
             mvi a,h'20             ; Set to space char. ' '

wh_loop:     cmp m                  ; Is the buffer at a space?
             jz end_ins             ; If so, we're at the end of the ins.
             inx h                  ; Inc pointer
             dcr c                  ; Dec counter
             jz ugh_oh              ; If the ctr is 0, the user screwed up
             jmp wh_loop            ; Otherwise, keep doing it                                   

end_ins:     inx h                  ; Inc the buffer pointer
             xchg                   ; Mov DE-HL
             pchl                   ; Point the PC to the app. subroutine

whertabl:    .dw upload,download,assemble,disasm,go           ; Addr
             .dw retgo,ss,indata,more,outdata,comp,menu,math  ; \
             .dw edit,ascedit,dump,ascdump,swap,move          ; /
             .dw compare,register,what,yet_menu               ; table.
             .dw fill,divide,multiply,hunt,test,games    
             .dw clear,about

ins_tabl:    .db "UPDOASDIGORESSINMOOUCMMEMAED"               ; Valid ins.
             .db "AEDUADSWMVCORGWHYEFIDVMUHUTEGACLAB"             ; table.


;Disassembler- Use H/L to store where to start.  disasm1 gives a single
;instruction.  disasm16 gives 16. 


disasm1:     xra a                  ; Set acc to 1
             inr a                  ; Inc to 1
             jmp disloop            ; By-pass 'MVI a,16'

disasm16:    mvi a,16               ; Set-up for 16 mnemonics
             
disloop:     push psw               ; Save mnemonic counter
             push h                 ; Save pointer
             push h                 ; Twice!
             shld buffer            ; Store HL temporally
             lxi h,buffer           ; Point to buffer
             call showword          ; Store the text-version in the buffer
             lxi h,discol           ; Show the ':    ' string
             call string            ; Store it
             pop h                  ; Get the saved pointer
             lxi d,buffer           ; Pointer to buffer
             push d                 ; Save it
             call docode            ; Show the 1st byte of it
             push b                 ; Save it..
             push b                 ; Twice!
             dcx h                  ; DCX pointer
             call showbyte          ; Show the byte
             pop b                  ; Get saved pointer
             mov a,b                ; Mov mode to acc
             ora a                  ; If it's 0, it's a 1 byte mnemonic
             jz no_more1            ; If so, quit
             push b                 ; Save mode
             mvi a,1                ; Store 1 space
             call space             ; Do it
             call showbyte          ; Show the 2nd byte
             pop b                  ; Get mode
             dcr b                  ; dcr it
             jz no_more2            ; Is it a 2byte ins? Is so, no more
             mvi a,1                ; Store another space
             call space             ; Do it
             call showbyte          ; Show the 3rd byte
             mvi a,4                ; Store 4 spaces
             call space             ; Do it
             
dis_back:    pop b                  ; Get saved mode
             pop h                  ; Get saved pointer
             push b                 ; Save mode *again*
             call string            ; Send out mnemonic
             pop b                  ; Get mode
             pop h                  ; Get pointer
             inx h                  ; Inc pointer
             mov a,b                ; Mov mode to a
             ora a                  ; Is it 0?
             jz donediss            ; If so, we're done
             dcr a                  ; Is it a 2 byte ins?
             jz mode1               ; If so, jump
             call showword          ; Otherwise, show the word
             inx h                  ; Inc pointer

donediss:    call crlf              ; We're done! : Show a CRLF
             pop psw                ; Get saved counter
             dcr a                  ; DCR counter
             jnz disloop            ; If not done, do it again
             ret                    ; Return

discol:      .db ":    \0"          ; Seperator for dissassembly output

no_more1:    mvi a,10               ; Show 10 spaces
             call space             ; For 1 byte mnemonic
             jmp dis_back           ; Go back

no_more2:    mvi a,7                ; Show 7 spaces
             call space             ; For 2 byte mnemonic
             jmp dis_back           ; Go back

space:       push psw               ; Save # of spaces
             mvi b,' '              ; Show space
             call put_byte            ; Send it out
             pop psw                ; Get counter
             dcr a                  ; DCR it
             jnz space              ; Is it 0? If not, keep doing it
             ret                    ; Return

mode1:       call showbyte          ; Show the byte in a 2 byte op-code
             jmp donediss           ; We're done!

showword:    inx h                  ; Inc pointer
             call showbyte          ; Show the 1st byte of the word
             dcx h                  ; Dec 
             dcx h                  ; Dec to point to other byte

showbyte:    push h                 ; Save pointer
             mvi b,0                ; Set b to 0 for later ops
             mov a,m                ; Get byte
             rrc                    ; Do 
             rrc                    ;  a
             rrc                    ;   nybble
             rrc                    ;  SWAP
             push h                 ; Save pointer
             lxi h,hextabl          ; Point to table
             ani h'f                ; AND to strip upper nybble
             mov c,a                ; Mov to c
             dad b                  ; Adjust pointer
             mov b,m                ; Mov Hex nybble to B
             call put_byte          ; Send it out
             pop h                  ; Get saved pointer
             mov a,m                ; Get byte
             mvi b,0                ; Set B to 0
             ani h'f                ; Get lower nybble
             mov c,a                ; Adjust it
             lxi h,hextabl          ; Point to table
             dad b                  ; Adjust pointer
             mov b,m                ; Mov result to B
             pop h                  ; Pop pointer
             inx h                  ; Inc pointer
             jmp put_byte           ; Send nybble and return

hextabl:     .db "0123456789ABCDEF" ; Table for hex conversion
             .db "0123456789abcdef" ; LC table (cheater! ;-)

string:      mov b,m                ; Mov byte to B reg for displaying
             xra a                  ; Set acc to 0
             cmp b                  ; Is B a null?
             rz                     ; If so, return
             call put_byte          ; Otherwise, show the byte
             inx h                  ; Inc pointer
             jmp string             ; Keep doing it

crlf:        mvi b,10               ; Set for a CR
             call put_byte          ; Output it
             mvi b,13               ; Set for a LF
             jmp put_byte           ; Output it & return



; This returns the correct mnemonic in the space starting at D/E.
; Use H/L for the address.  H/L will be incremented the proper
; number of times and point to the new address.  The C reg will hold
; how many bytes the output buffer has in it.  The B reg will have
; how many bytes the instruction takes -1.  This section of code uses
; the bit setup of the instructions to figure out the correct
; mnemonic.  A very nice piece of code if I do say so myself! ;-)

docode:      call getcode           ; Get the mnemonic                          
             xra a                  ; Store a null at the end
             stax d                 ; Store it
             ret                    ; Return

getcode:     mvi b,0                ; Clear the B reg for later table addring
             mvi a,h'76             ; Value for 'HLT'
             cmp m                  ; Is our byte 'HLT'?
             jz halt_put            ; If so, jump
             mvi a,h'22             ; Value for 'SHLD'
             cmp m                  ; Is our byte 'SHLD'?
             jz putstore            ; If so, jump
             mvi a,h'2a             ; Value for 'LHLD'
             cmp m                  ; Is our byte 'LHLD'?
             jz putload             ; If so, jump
             mvi a,h'c0             ; Get the upper 2 bits
             ana m                  ; These are used to break the op-codes
             rlc                    ;   up into 4 sections
             rlc                    ;
             ora a                  ; Is it bank 0?
             jz type0               ; If so, jump
             dcr a                  ; Try for bank 1
             jz type1               ; If it is, jump
             dcr a                  ; Try for bank 2
             jz type2               ; If it is, jump

type3:       mvi a,7                ; Check to see if it's a conditional
             ana m                  ;   by looking for %xxxx xx11 1 <---
             rrc                    ; The CY bit (%cxxx xxxc) tells.
             jc not_cond            ; If it's set, the op-code isn't a cond.
             cpi 3                  ; If %xxxx x11x, then we have a immediate
             jz imm_op              ; Sample immediate:  ADI, ACI, ANI, etc.
             push h                 ; Save the data pointer
             mov c,a                ; Move %xxxx xxnn to the C reg
             lxi h,cond_typ         ; Point to the cond. type table
             dad b                  ; Point to table entry
             mov a,m                ; Get the entry
             pop h                  ; Get our saved data pointer 
             call sto_one           ; Store the type. (i.e. JMP, CALL, RET)
             mvi a,h'38             ; Strip away bits for cond. type
             ana m                  ; Start:  %00nn n000
             rrc                    ; 
             rrc                    ; Finish: %0000 nnn0
             push h                 ; Save data pointer
             lxi h,mode             ; Point to cond. mode table
             mov c,a                ; Mov adjusted mode into C
             dad b                  ; Point to entry
             mov a,m                ; Retrieve entry (Z,NZ- RZ, JNZ)
             call sto_one           ; Store first letter
             inx h                  ; Inc pointer
             mov a,m                ; Get 2nd letter
             ora a                  ; Is it 0? (i.e. No second letter- JZ)
             cnz sto_one            ; If so, don't store it.
             mvi a,' '              ; Load a space
             call sto_one           ; Store the space
             pop h                  ; Retrieve the data pointer               
             mvi a,7                ; Is it a Rxx (i.e. RZ, RNZ) as opposed
             ana m                  ; to a Jxx or Cxx?
             inx h                  ; Inc pointer to next address
             rz                     ; If it is a Rxx, quit
             jmp sto_word           ; Otherwise store the 16-bit address/quit 

cond_typ:    .db "RJC"              ; The 3 types of conditionals

mode:        .db "NZZ\0NCC\0POPEP\0M\0"  ; The conditional modes

halt_put:    push h                 ; Save the data pointer
             lxi h,halt             ; Point to the 'HLT' mnemonic
             call sto_part          ; Save the part
             pop h                  ; Get the data pointer
             inx h                  ; Point to next address
             ret                    ; Quit

putload:     push h                 ; Save the data pointer
             lxi h,loadhl           ; Point to 'LHLD' mnemonic
             
cheat3:      call sto_part          ; Save the part
             pop h                  ; Get the data pointer
             inx h                  ; Point to next address
             jmp sto_word           ; Store the 16-bit address then quit

putstore:    push h                 ; Save the data pointer
             lxi h,storehl          ; Point to 'SHLD' mnemonic
             jmp cheat3             ; 'Cheat' ;)
                                    
storehl:     .db "SHLD \0"          ; Mnemonics
loadhl:      .db "LHLD \0"          ;
halt:        .db "HLT\0"            ;

imm_op:      mvi a,h'38             ; Take %00nn n000 convert to
             ana m                  ;      %0000 nnn0 for table; The table's
             rrc                    ;   entries are 2 bytes each.  Simple   
             rrc                    ;   way to get them!
             push h                 ; Save data pointer
             lxi h,imm              ; Point to the immediates (ie AC in ACI)
             mov c,a                ; Mov desired entry to C
             dad b                  ; Point to correct entry
             mov a,m                ; Get the letter
             call sto_one           ; Store it
             inx h                  ; Inc pointer
             mov a,m                ; Get the next letter
             call sto_one           ; Store it
             pop h                  ; Get the saved data pointer
             mvi a,'I'              ; Get an 'I' (For anI, acI, orI, etc.)
             call sto_one           ; Store it
             mvi a,' '              ; Get a space
             call sto_one           ; Store it
             inx h                  ; Inc the data pointer to the next byte
             jmp sto_byte           ; Store the data byte and quit
                                     
imm:         .db "ADACSUSBANXRORCP" ; The immediate mnemonics (1st 2 letters)

not_cond:    ani 3                  ; Not a conditional; get 2 bits to break
             cpi 3                  ;   up instructions.  %0000 00nn
             jz restrt              ; If it's 3, it's a 'RST n' mnemonic
             ora a                  ; Compare to 0
             jz misc2               ; If so, it's a misc2 mnemonic
             cpi 1                  ; Compare to 1
             jz misc3               ; If so, it's a misc3 mnemonic
             mvi a,8                ; It's a misc4- fallthrough
             ana m                  ; Is it a PUSH rp mnemonic?
             jz stack0              ; If not set, it is
             mvi a,h'30             ; Get 2 bits to determine what the 
             ana m                  ;   mnemonic is.
             rrc                    ; Multiply the value by 5 to match up
             rrc                    ;   with the table entries
             mov c,a                ;
             rrc                    ;
             rrc                    ;
             add c                  ;
             mov c,a                ; Mov the table entry # into C
             push h                 ; Save the data pointer
             lxi h,misc_op2         ; Point to table
             dad b                  ; Point to correct entry
             call sto_part          ; Save the mnemonic
             mvi a,' '              ; Get a space
             call sto_one           ; Store it
             pop h                  ; Get data pointer
             mvi a,h'ed             ; Is it the HLDE opcode?
             cmp m                  ; Do the compare
             inx h                  ; Inc the pointer in case we return
             rz                     ; Return if it's HLDE
             dcx h                  ; Dec the pointer back

cheat0:      inx h                  ; Inc the pointer
             jmp sto_word           ; Save the 16-bit word (all are 3byte mn)
             
misc_op2:    .db "CALL\0J1C\0!LHLV\0J1S\0"  ; The 4 misc4 mnemonics

stack0:      push h                 ; Save the data pointer
             lxi h,stack_ps         ; Point to 'PUSH '
             
cheater:     call sto_part          ; Save it
             pop h                  ; Get data pointer
             mvi a,h'30             ; Get what type of PUSH or POP it is
             ana m                  ; START: %00nn 0000
             rrc                    ;
             rrc                    ; END:   %0000 0nn0
             rrc                    ;
             push h                 ; Save data pointer
             lxi h,pairs2           ; Point to RP designations (B, D, etc)
             mov c,a                ; Mov to C
             dad b                  ; Adjust pointer
             call sto_part          ; Store the designation
             pop h                  ; Get the data pointer                     
             inx h                  ; Inc the pointer
             ret                    ; Quit

pairs2:      .db "B\0D\0H\0PSW\0"   ; PUSH/POP designations

stack_ps:    .db "PUSH \0"          ; PUSH mnemonic

misc2:       mvi a,8                ; Is it a POP mnemonic?
             ana m                  ; Check
             jz stack1              ; If it's cleared, it's a POP
             push h                 ; Save data pointer
             mvi a,h'30             ; Get the 2 bit number, multiply it
             ana m                  ;   by 5, and put it in the C reg                                 
             rrc                    ;
             rrc                    ;
             mov c,a                ;
             rrc                    ;
             rrc                    ;
             add c                  ;
             mov c,a                ;
             lxi h,misc_op3         ; Point to misc2 mnemonics
             dad b                  ; Point to new location
             call sto_part          ; Save the mnemonic
             pop h                  ; Get data pointer
             inx h                  ; Inc the pointer
             ret                    ; Quit

misc_op3:    .db "RET\0!SHLV\0PCHL\0SPHL\0"   ; The 4 misc2 mnemonics

misc3:       mvi a,h'38             ; Get 3 bits of the op-code
             ana m                  ; Multiply them by 5 to get
             rrc                    ;   a table offset
             mov c,a                ;
             rrc                    ;
             rrc                    ;
             add c                  ;
             mov c,a                ; Mov it to the C reg
             push h                 ; Save the data pointer
             lxi h,misc_op4         ; Point to the table
             dad b                  ; Point to new table entry
             call sto_part          ; Store the mnemonic
             pop h                  ; get the pointer
             mvi a,h'20             ; Is it a 1 byte mnemonic?
             ana m                  ; Find out
             inx h                  ; Adj pointer
             rnz                    ; If so, quit
             mvi a,h'cb             ; Is it ZRST?
             dcx h
             cmp m                  ; Check
             inx h
             rz                     ; Is it a zret? If so, one byte
             dcx h                  ; Un-adj pointer
             mvi a,h'10             ; Is it a 2 byte mnemonic?
             ana m                  ; Check bit
             jz cheat0              ; If it's 0, it's 16 bit
             jmp cheat1             ; Yup. it's a 2 byte one

misc_op4:    .db "JMP \0ZRST\0OUT \0IN \0!"  ; The 8 misc 3
             .db "XTHL\0XCHG\0DI\0!!EI\0"    ;   mnemonics.

stack1:      push h                 ; Save data pointer
             lxi h,stack_pp         ; Point to 'POP '
             jmp cheater            ; 'Cheat'!!! ;)
            
stack_pp:    .db "POP \0"           ; Mnemonic

restrt:      push h                 ; Save data pointer
             lxi h,restart          ; Point to 'RST '
             call sto_part          ; Store it
             pop h                  ; Get data pointer
             push h                 ; Save it again
             mvi a,h'38             ; Get %00nn n000
             ana m                  ;
             rrc                    ;
             rrc                    ;
             rrc                    ; Rotate to  %0000 0nnn
             adi h'30               ; Add h'30 to make a decimal #
             call sto_one           ; Store it
             pop h                  ; Get data pointer
             inx h                  ; Inc pointer
             ret                    ; Quit

restart:     .db "RST \0"           ; Mnemonic

type0:       mvi a,4                ; If bit 3 is set, it's a rp mnemonic
             ana m                  ; Is it?
             jz rp_group            ; If clear, it is
             mvi a,3                ; Is it a misc0?
             ana m                  ; Get the value
             cpi 3                  ; Do the compare
             jz misc0               ; If so, jump
             rlc                    ; Multiply the value by 4
             rlc                    ; To align w/ table entries
             push h                 ; Save data pointer
             lxi h,otr_reg          ; Point to table
             mov c,a                ; Mov to C
             dad b                  ; Point to correct entry
             call sto_part          ; Store it
             pop h                  ; Get data pointer
             mvi a,' '              ; Get a space
             call sto_one           ; Store it
             mvi a,h'38             ; Get %00nn n000
             ana m                  ; Continue
             rrc                    ;  with 
             rrc                    ;   the
             rrc                    ;    bit
             dcx h                  ;   manipulation/
             call show_reg          ;  conversion
             mvi a,3                ; Get lower 2 bits
             ana m                  ; From pointed-to location
             inx h                  ; Inc pointer
             cpi 2                  ; Is it a 1 byte mnemonic?
             rnz                    ; If so, quit
             dcx h                  ; Dec pointer
             mvi a,','              ; Put a ',' for MVI R,nn 
             call sto_one           ; Store it                  

cheat1:      inx h                  ; Inc the pointer
             mov a,m                ; Mov the byte
             jmp sto_byte           ; Store it and quit

otr_reg:     .db "INR",0,"DCR",0,"MVI",0  ; 3 mnemonics for type0

misc0:       mvi a,h'38             ; Get %00nn n000
             ana m                  ; From memory
             rrc                    ; div by 2
             push h                 ; Save data pointer
             lxi h,misc_op0         ; Point to table
             jmp show_msc                                     
             
misc_op0:    .db "RLC",0,"RRC",0,"RAL",0,"RAR",0  ; The 8 mnemonics
             .db "DAA",0,"CMA",0,"STC",0,"CMC",0  ; for misc0

rp_group:    mvi a,7                ; Mask for which RP ins. it is
             ana m                  ; And op-code w/ mask
             jz misc1               ; It's not a RP instruction
             mvi a,8                ; ] 
             ana m                  ; ]
             rrc                    ; ]
             mov c,a                ; ] Adjust bits for easy manipulation
             mvi a,3                ; ]
             ana m                  ; ]
             ora c                  ; ]
             dcr a                  ; Done manipulation
             push h                 ; Save op-code location
             lxi h,pair_op          ; Point to RP ops
             rlc                    ; Adjust pointer
             rlc                    ; By multiplying 4 times
             mov c,a                ; Mov to add
             dad b                  ; Do the adjustment
             call sto_part          ; Store the mnemonic- text part
             pop h                  ; Get saved op-code addr
             mvi a,3                ; Mask for RP instruction
             ana m                  ; Get RP instruction
             dcr a                  ; Check to se if it's &h01
             dcr a                  ; 
             jz loadacc             ; If 0, then it's an LDA(X) Ins.
             mvi a,' '              ; Otherwise, store a space
             call sto_one           ; Store it
       
sto_rp:      mvi a,h'30             ; Get the actual RP
             ana m                  ;
             rrc                    ;
             rrc                    ;
             rrc                    ;
             rrc                    ;
             mov c,a                ; The pair is now in BC
             push h                 ; Save op-code location
             lxi h,pairs            ; Point to correct entry
             dad b                  ; Adjust table
             mov a,m                ; Get the character
             call sto_one           ; Store it in the buffer
             pop h                  ; Get saved pointer
             mvi a,h'30             ; Is it a 'SP' instruction?
             ana m                  ; Find out
             cpi h'30               ; Do the compare
             mvi a,'P'              ; If so, store a 'P' to make 'SP'
             cz sto_one             ; Store it in the buffer
             mvi a,h'f              ; Is it an ins. that needs a comma?
             ana m                  ;
             dcr a                  ;
             inx h                  ;
             rnz                    ; Nope, return
             dcx h                  ; Otherwise,
             mvi a,','              ; Store one in the buffer
             call sto_one           ; Store it
             
sto_two:     inx h                  ; Inc the data pointer
             jmp sto_word           ; Setup B reg for a word
             
pairs:       .db "BDHS"             ; Table of RP's

pair_op:     .db "LXI",0,"STA",0,"INX",0,"XXX",0   ; RP Mnemonics
             .db "DAD",0,"LDA",0,"DCX",0           ;

loadacc:     mvi a,h'30             ; Is it an 'LDA xxxx' instruction?
             ana m                  ; Find out
             cpi h'30               ; Do compare
             jz real_lda            ; If 0, it is an 'LDA xxxx' instruction
             mvi a,'X'              ; Otherwise, store an 'X' for 'LDAX rp'
             call sto_one           ; Store the character
             mvi a,' '              ; Store a space
             call sto_one           ; Store it
             jmp sto_rp             ; Jmp to get it's RP

real_lda:    mvi a,' '              ; Store a space
             call sto_one           ; Store it
             jmp sto_two            ; Quit, storing the ???

misc1:       mvi a,h'38             ; Set mask for what type of op-code
             ana m                  ; Do the AND
             rrc                    ; Adjust for easy manipulation
             mov c,a
             rrc
             rrc
             add c
             push h                 ; Save pointer to op-code
             lxi h,misc_op1         ; Point to mnemonic type
             
show_msc:    mov c,a
             dad b                  ; Mov for adjusting
             call sto_part          ; Point to table location
             pop h                  ; Get saved pointer
             inx h                  ; Inc pointer
             ret                    ; Return

misc_op1:    .db "NOP\0!DSUB\0ARHL\0RDEL\0"   ; Table for bank 0
             .db "RIM\0!DEHL\0SIM\0!DESP\0"    ; misc. mnemonics

type1:       push h                 ; Save pointer
             lxi h,movreg           ; Point to the string 'MOV '
             call sto_part          ; Store it
             pop h                  ; Get saved pointer
             mvi a,h'38             ; Get 1st reg
             ana m                  ; AND mask
             rrc                    ; Adjust:
             rrc                    ; %00nn n000
             rrc                    ; to
             dcx h                  ; 00000 0nnn : Dec pointer
             call show_reg          ; Save by using twice! :-)
             mvi a,','              ; Show a comma: 'MOV r,'
             call sto_one           ; Store it
             mvi a,7                ; Get 2nd register
             ana m                  ; And mask
             
show_reg:    push h                 ; Save pointer
             mov c,a                ; Mov for adjustment
             lxi h,regs             ; Point to reg list
             dad b                  ; Adjust pointer
             mov a,m                ; Get the register
             call sto_one           ; Store it
             pop h                  ; Get pointer
             inx h                  ; Inc pointer
             ret                    ; Return

regs:        .db "BCDEHLMA"         ; Table of the 8 regs

movreg:      .db "MOV \0"           ; Text string for the MOV mnemonic

type2:       mvi a,h'38             ; This is for reg-ops: i.e. 'ADD r'
             ana m                  ; AND mask
             rrc                    ; Adjust
             mov c,a                ; Mov to adjust
             push h                 ; Save pointer
             lxi h,regops           ; Point to reg-op list
             dad b                  ; Point to table entry
             call sto_part          ; Store the mnemonic: i.e. 'ADD'
             mvi a,' '              ; Store a space afterwards
             call sto_one           ; Store it
             pop h                  ; Get pointer
             mvi a,7                ; Set up for which register
             ana m                  ; AND mask
             jmp show_reg           ; Show the register & return
             
regops:      .db "ADD",0,"ADC",0,"SUB",0,"SBB",0 ; Table for the 8
             .db "ANA",0,"XRA",0,"ORA",0,"CMP",0 ; register ops

sto_one:     stax d                 ; Store data byte where D/E is pointing
             inx d                  ; Inc for next location
             ret                    ; Quit

sto_part:    mov a,m                ; Get byte
             ora a                  ; Is it null?
             rz                     ; If so, return
             call sto_one           ; Otherwise, store it
             inx h                  ; Inc pointer
             jmp sto_part           ; Keep doing it

sto_byte:    mvi b,1                ; Set for 1 byte op
             ret                    ; Return

sto_word:    mvi b,2                ; Set for 2 byte op
             ret                    ; Return
             
;Decompresses data using the Huffman method.  H/L stores
;start; output goes to serial port.

dcomp:       xchg                   ; Mov pointer around
             mvi b,h'80             ; Set up bit-mask
             
newchar:     lxi h,dcomptbl         ; Point to de-comp table
                                    
dcomloop:    call get_bit           ; Get a bit
             jz no_inc              ; If it's a 0, don't inc pointer (left)
             inx h                  ; Otherwise, it's a branch right                              

no_inc:      mov a,m                ; Get table's data
             push psw               ; save it
             ani h'80               ; check to see if it's a 'branch'
             jz donedcom            ; If a 0, it's not
             pop psw                ; Get saved byte
             ani h'7f               ; Strip high bit
             push b                 ; Save bit-counter
             rlc                    ; Mult. by 2
             mov c,a                ; Mov it to adjust0
             mvi b,0                ; Clear high byte
             lxi h,dcomptbl         ; Point to table
             dad b                  ; Set new pointer
             pop b                  ; Get saved stuff
             jmp dcomloop           ; Keep walking down tree

donedcom:    pop psw                ; Avoid smashing the stack
             push b                 ; Save the bit-counter
             push d                 ; Save the datapointer
             mov b,a                ; Mov so we can send it out the RS-232
             ora a                  ; Is it a null?
             jz thatsall            ; If so, return
             cpi ';'                ; Is it an un-compressed byte?
             jz no_huf              ; If so, get it
             cpi 10                 ; Is it a CRLF
             push psw               ; Save flags
             cz crlf                ; If so, send it out
             pop psw                ; Get saved flags
             cnz put_byte           ; If not, show the byte
             pop d                  ; Get saved datapointer
             pop b                  ; Get saved bit-counter
             jmp newchar            ; Get another character

thatsall:    pop d                  ; Get saved RP's so we don't
             pop b                  ;  smash the stack! (experienced it!! :-)
             ret                    ; Return

no_huf:      pop d                  ; Get saved
             pop b                  ; RP's.
             lxi h,h'0800           ; Set bit-counter to 8 & bitholder to 0

n_h_loop:    call get_bit           ; Get 
             stc                    ;  the
             cz no_cy               ;   un-compressed
             mov a,l                ;   byte
             ral                    ;  into 
             mov l,a                ; L.
                                    
             dcr h                  ; Dec the bit counter
             jnz n_h_loop           ; Last bit?  If not, keep getting bits
             push d                 ; Save 
             push b                 ; both RP's.
             mov b,l                ; Mov byte to B for displaying
             call put_byte          ; Show it
             pop b                  ; Get saved
             pop d                  ; RP's.
             jmp newchar            ; Get another char

no_cy:       cmc                    ; Set the CY
             ret                    ; flag to 0 & return.

get_bit:     ldax d                 ; Get the current byte
             ana b                  ; AND with bit-counter                    
             ora a                  ; Is it a 0 or 1?
             push psw               ; Save result
             mov a,b                ; Rotate bit-counter right
             rrc                    ; to point to next bit
             mov b,a                ; for de-compression
             cpi h'80               ; Is it time for another byte?
             cz inc_addr            ; If so, inc byte counter
             pop psw                ; Get saved result
             ret                    ; Return

inc_addr:    inx d                  ; Inc the datapointer
             ret                    ; Return

; The De-Compression Table holds the binary tree for the Huffman decoder.
; A 'branch' is specified by the high-bit being set; i.e. '89' would mean
; jumping to entry 09.  Note that an 'entry' is 2 bytes in length!! So '89'
; would point to byte d16 in the table (or entry #8).  A 0 indicates a
; branch left (use left value) and a 1 indicates a right branch (use right
; value).  

dcomptbl:    .db  h'81,h'82,  h'9e,h'8c,  h'83, "-",  h'84, "T"  ; 00-03
             .db  h'85, "D",  h'86, "S",  h'87, "Y",  h'88, "H"  ; 04-07
             .db  h'89, "W",  h'8a,h'8b,   "=", "K",   "^", "}"  ; 08-0b
             .db   " ",h'8d,  h'9c,h'8e,   "R",h'8f,  h'90, "N"  ; 0c-0f
             .db  h'91,h'94,   "B",h'92,   "V",h'93,   "{", "|"  ; 10-13
             .db  h'95, "!",  h'96,h'99,  h'97,h'98,   ":", ";"  ; 14-17
             .db   ".", "/",  h'9a,h'9b,   ")", "+",   "&", "("  ; 18-1b
             .db   "A",h'9d,   "\n","M",  h'a6,h'9f,   "E",h'a0  ; 1c-1f
             .db  h'a1,h'a2,   "P", "U",  h'a4,h'a3,   "G", ","  ; 20-23
             .db  h'a5, "L",   "]", "[",   "O",h'a7,  h'a8, "X"  ; 24-27
             .db   "I",h'a9,  h'aa,h'ab,  "\0",h'7f,   "C", "F"  ; 28-2b

; The menus

ms_menu:     .db h'49,h'24,h'2C,h'0D,h'B6,h'C7,h'E5,h'44,h'D6,h'DB
             .db h'63,h'A1,h'7A,h'0D,h'34,h'D1,h'A6,h'21,h'9F,h'85
             .db h'7F,h'FF,h'FF,h'A3,h'4C,h'3A,h'0C,h'95,h'2C,h'AC
             .db h'42,h'EE,h'06,h'D0,h'D5,h'05,h'0B,h'52,h'10,h'2F
             .db h'A3,h'91,h'9C,h'2F,h'FF,h'FF,h'52,h'10,h'2F,h'9D
             .db h'06,h'4A,h'96,h'56,h'28,h'D6,h'3A,h'88,h'F9,h'E4
             .db h'CA,h'86,h'D3,h'22,h'DA,h'1A,h'FF,h'FF,h'FF,h'D3
             .db h'23,h'12,h'6D,h'E0,h'E9,h'28,h'D6,h'3A,h'88,h'F9
             .db h'E4,h'CA,h'86,h'D4,h'89,h'18,h'A1,h'AF,h'FF,h'FF
             .db h'F5,h'22,h'46,h'2C,h'8C,h'49,h'B7,h'83,h'A4,h'A3
             .db h'58,h'EA,h'23,h'E7,h'93,h'2A,h'1B,h'47,h'81,h'0D
             .db h'7F,h'FF,h'FF,h'FA,h'21,h'90,h'B1,h'B4,h'94,h'6B
             .db h'1D,h'44,h'7C,h'F2,h'65,h'43,h'69,h'C5,h'4F,h'02
             .db h'1A,h'FF,h'FF,h'FD,h'10,h'C8,h'58,h'DA,h'48,h'5D
             .db h'C0,h'DA,h'1A,h'35,h'FA,h'21,h'D4,h'C4,h'E2,h'AD
             .db h'46,h'2B,h'FF,h'FF,h'FF,h'FD,h'44,h'47,h'CF,h'1D
             .db h'2E,h'34,h'8C,h'4D,h'84,h'93,h'42,h'3E,h'86,h'BF
             .db h'FF,h'FF,h'FD,h'1E,h'2A,h'A5,h'95,h'88,h'5D,h'C0
             .db h'DA,h'30,h'1D,h'50,h'DA,h'03,h'6A,h'1A,h'FF,h'FF
             .db h'FF,h'D4,h'49,h'F9,h'52,h'CA,h'C5,h'41,h'18,h'0E
             .db h'A8,h'6D,h'0B,h'36,h'62,h'1A,h'FF,h'FF,h'FF,h'D0
             .db h'B0,h'36,h'61,h'D2,h'6C,h'9F,h'AA,h'59,h'58,h'81
             .db h'F4,h'60,h'3A,h'A1,h'B4,h'D9,h'3E,h'6A,h'FF,h'FF
             .db h'FF,h'F5,h'60,h'89,h'15,h'60,h'88,h'F9,h'E6,h'9B
             .db h'65,h'82,h'9E,h'60,h'32,h'03,h'19,h'F8,h'57,h'FF
             .db h'A9,h'04,h'DB,h'2C,h'14,h'0F,h'A1,h'BD,h'38,h'52
             .db h'03,h'20,h'03,h'97,h'AA,h'7F,h'3F,h'01,h'1F,h'79
             .db h'CF,h'BD,h'63,h'86,h'8A,h'44,h'A8,h'6B,h'FF,h'FF
             .db h'FD,h'14,h'89,h'54,h'B2,h'B1,h'32,h'A1,h'B4,h'C2
             .db h'7E,h'93,h'90,h'D7,h'FF,h'FF,h'A6,h'44,h'58,h'41
             .db h'14,h'B2,h'B1,h'13,h'F5,h'D0,h'A6,h'54,h'36,h'A4
             .db h'D6,h'CC,h'43,h'3F,h'0A,h'FF,h'FF,h'F5,h'26,h'B6
             .db h'62,h'96,h'56,h'21,h'77,h'03,h'68,h'6A,h'82,h'85
             .db h'A6,h'49,h'AD,h'98,h'86,h'7E,h'15,h'FF,h'FF,h'A6
             .db h'44,h'58,h'41,h'14,h'9A,h'D9,h'88,h'5D,h'C0,h'DA
             .db h'1A,h'A0,h'A1,h'69,h'B0,h'71,h'2F,h'FF,h'FF,h'FF
             .db h'4D,h'83,h'89,h'46,h'9A,h'2E,h'2E,h'F6,h'F6,h'D3
             .db h'42,h'80

ms_more:     .db h'49,h'26,h'C1,h'C4,h'85,h'81,h'B6,h'D8,h'FC,h'C5
             .db h'E8,h'34,h'D3,h'51,h'81,h'61,h'8A,h'04,h'F8,h'CF
             .db h'C2,h'BF,h'FF,h'F5,h'18,h'16,h'18,h'A0,h'77,h'A2
             .db h'7C,h'35,h'02,h'25,h'82,h'A2,h'C6,h'C9,h'3E,h'6B
             .db h'6F,h'04,h'E4,h'02,h'E9,h'E2,h'1A,h'51,h'69,h'24
             .db h'92,h'49,h'24,h'92,h'49,h'24,h'92,h'8D,h'63,h'A8
             .db h'8F,h'9E,h'4C,h'AA,h'16,h'9B,h'79,h'28,h'13,h'E3
             .db h'3F,h'0A,h'FF,h'FF,h'FD,h'36,h'0F,h'24,h'D9,h'36
             .db h'0E,h'85,h'3C,h'1D,h'01,h'68,h'05,h'40,h'EF,h'44
             .db h'F8,h'6A,h'82,h'6C,h'9B,h'51,h'AC,h'75,h'11,h'F3
             .db h'C9,h'95,h'42,h'D0,h'B0,h'36,h'62,h'81,h'3E,h'33
             .db h'F0,h'AF,h'FF,h'FD,h'0B,h'03,h'66,h'31,h'C4,h'9E
             .db h'89,h'92,h'78,h'3A,h'02,h'D0,h'0C,h'50,h'0B,h'A6
             .db h'C9,h'B0,h'74,h'29,h'8F,h'CA,h'69,h'24,h'92,h'49
             .db h'24,h'92,h'49,h'24,h'92,h'71,h'18,h'0E,h'A9,h'8F
             .db h'C2,h'98,h'F8,h'36,h'C3,h'A2,h'14,h'5A,h'71,h'E8
             .db h'AF,h'FF,h'FF,h'FF,h'F5,h'18,h'21,h'02,h'AC,h'12
             .db h'4E,h'23,h'C2,h'46,h'93,h'A2,h'D3,h'8F,h'45,h'1C
             .db h'B1,h'E0,h'5A,h'4A,h'09,h'D3,h'83,h'E7,h'23,h'38
             .db h'5E,h'9B,h'09,h'10,h'5E,h'14,h'F4,h'4E,h'37,h'81
             .db h'2A,h'71,h'1E,h'69,h'C7,h'A2,h'8E,h'5E,h'05,h'9E
             .db h'79,h'27,h'9E,h'09,h'D3,h'83,h'E7,h'23,h'38,h'F4
             .db h'D8,h'48,h'82,h'F0,h'A7,h'A2,h'62,h'F4,h'4D,h'B7
             .db h'81,h'2A,h'71,h'1E,h'69,h'C7,h'A2,h'8E,h'4C,h'8B
             .db h'CE,h'60,h'B1,h'C1,h'F3,h'91,h'9C,h'2F,h'F4,h'D8
             .db h'48,h'82,h'F0,h'A6,h'D8,h'2D,h'04,h'47,h'C9,h'38
             .db h'8F,h'34,h'E3,h'D1,h'42,h'E7,h'22,h'E7,h'58,h'78
             .db h'E0,h'E5,h'E8,h'98,h'3C,h'EF,h'44,h'C4,h'E3,h'FD
             .db h'36,h'12,h'20,h'BC,h'28,h'5C,h'EB,h'0F,h'35,h'09
             .db h'55,h'FF,h'FF,h'FF,h'FE,h'A1,h'2A,h'85,h'5B,h'07
             .db h'10,h'AA,h'8D,h'34,h'5C,h'5D,h'ED,h'ED,h'ED,h'ED
             .db h'A6,h'9F,h'0A,h'4F,h'41,h'08,h'FC,h'6B,h'8D,h'16
             .db h'A2,h'03,h'F1,h'42,h'CC,h'7D,h'3C,h'12,h'8C,h'10
             .db h'75,h'27,h'CA,h'55,h'04,h'F4,h'4C,h'90,h'B4,h'16
             .db h'39,h'82,h'D4,h'9D,h'17,h'A0,h'D0,h'8F,h'48,h'9E
             .db h'92,h'7A,h'24,h'E5,h'22,h'54,h'2C,h'F4,h'4C,h'5E
             .db h'89,h'A4,h'BD,h'12,h'74,h'2C,h'C7,h'D3,h'C1,h'28
             .db h'C1,h'07,h'52,h'7C,h'A5,h'50,h'7A,h'09,h'3D,h'12
             .db h'72,h'94,h'2C,h'F4,h'4C,h'5E,h'89,h'A4,h'BD,h'12
             .db h'76,h'9A,h'14

ms_yet:      .db h'49,h'21,h'58,h'4A,h'8A,h'A6,h'C1,h'C4,h'85,h'81
             .db h'B6,h'D8,h'FC,h'C5,h'ED,h'E8,h'34,h'D3,h'50,h'30
             .db h'59,h'57,h'FF,h'FF,h'FF,h'EA,h'44,h'89,h'87,h'59
             .db h'0C,h'54,h'0C,h'16,h'55,h'61,h'30,h'90,h'0B,h'A6
             .db h'C9,h'B0,h'74,h'28,h'48,h'B4,h'92,h'49,h'24,h'92
             .db h'49,h'24,h'92,h'49,h'18,h'E2,h'89,h'3F,h'50,h'8F
             .db h'AB,h'04,h'93,h'D1,h'36,h'7A,h'26,h'90,h'0A,h'64
             .db h'CB,h'8A,h'31,h'51,h'31,h'82,h'C4,h'D0,h'B8,h'87
             .db h'4E,h'A8,h'13,h'E3,h'3F,h'0A,h'FF,h'FF,h'D0,h'B8
             .db h'87,h'4E,h'A8,h'1D,h'E8,h'9F,h'0D,h'40,h'89,h'60
             .db h'A8,h'5A,h'97,h'92,h'19,h'F8,h'57,h'FF,h'FF,h'FE
             .db h'A4,h'47,h'90,h'92,h'48,h'69,h'E2,h'15,h'0A,h'86
             .db h'00,h'7A,h'27,h'1B,h'C0,h'95,h'0E,h'00,h'7A,h'26
             .db h'2F,h'44,h'DB,h'78,h'12,h'B4,h'D9,h'A7,h'50,h'CF
             .db h'C2,h'BF,h'FF,h'FF,h'D3,h'66,h'9D,h'A2,h'18,h'76
             .db h'14,h'34,h'F1,h'0A,h'85,h'3D,h'04,h'34,h'F5,h'94
             .db h'30,h'03,h'D1,h'31,h'7A,h'26,h'DB,h'C0,h'95,h'A8
             .db h'26,h'BF,h'54,h'09,h'F1,h'9F,h'85,h'7F,h'FF,h'EA
             .db h'09,h'AF,h'D5,h'60,h'B8,h'D4,h'D9,h'36,h'0E,h'85
             .db h'0B,h'83,h'94,h'08,h'3A,h'54,h'2D,h'52,h'8D,h'47
             .db h'2F,h'44,h'C4,h'E1,h'7F,h'FF,h'FE,h'9C,h'46,h'03
             .db h'AA,h'07,h'D3,h'98,h'DA,h'7A,h'09,h'E8,h'98,h'AD
             .db h'10,h'E0,h'B0,h'D8,h'D1,h'1E,h'44,h'A9,h'46,h'B4
             .db h'92,h'49,h'24,h'92,h'49,h'24,h'92,h'49,h'00,h'BA
             .db h'73,h'1B,h'4F,h'5C,h'9E,h'44,h'E8,h'51,h'D0,h'16
             .db h'65,h'10,h'1F,h'D3,h'D1,h'35,h'7A,h'26,h'AA,h'C1
             .db h'27,h'D3,h'18,h'F5,h'1A,h'16,h'3A,h'4C,h'72,h'FF
             .db h'FF,h'FF,h'F4,h'2C,h'74,h'98,h'E8,h'AB,h'04,h'94
             .db h'45,h'9C,h'44,h'FB,h'4C,h'78,h'03,h'6A,h'FF,h'FF
             .db h'FF,h'F4,h'C7,h'80,h'36,h'AB,h'04,h'48,h'A6,h'C1
             .db h'F1,h'28,h'39,h'A6,h'85,h'00

ms_ssmnu:    .db h'49,h'24,h'94,h'62,h'9B,h'11,h'F1,h'36,h'C9,h'F3
             .db h'5E,h'83,h'4D,h'41,h'23,h'A6,h'2F,h'FF,h'FF,h'FF
             .db h'D5,h'82,h'24,h'54,h'12,h'3A,h'62,h'6C,h'9F,h'35
             .db h'A7,h'86,h'0B,h'40,h'2B,h'FF,h'FF,h'FF,h'F4,h'43
             .db h'12,h'A8,h'C5,h'36,h'12,h'4D,h'3D,h'13,h'C2,h'7E
             .db h'93,h'9E,h'89,h'F2,h'FF,h'FF,h'FF,h'51,h'A4,h'62
             .db h'07,h'C5,h'89,h'A7,h'1E,h'8A,h'FF,h'FF,h'FF,h'FF
             .db h'51,h'22,h'7A,h'68,h'5A,h'0B,h'1F,h'3C,h'49,h'C4
             .db h'78,h'48,h'D2,h'74,h'5A,h'8D,h'23,h'10,h'D7,h'FF
             .db h'FF,h'FE,h'A3,h'48,h'C4,h'35,h'44,h'6C,h'A2,h'D3
             .db h'61,h'24,h'86,h'BF,h'FF,h'FF,h'F5,h'12,h'A9,h'B0
             .db h'92,h'54,h'13,h'D1,h'30,h'40,h'E4,h'F4,h'4C,h'5A
             .db h'49,h'24,h'92,h'49,h'24,h'92,h'49,h'24,h'9E,h'89
             .db h'84,h'00,h'8D,h'7F,h'6C,h'1E,h'42,h'3E,h'79,h'46
             .db h'B2,h'9B,h'14,h'F0,h'C7,h'34,h'92,h'49,h'24,h'92
             .db h'49,h'24,h'92,h'49,h'3D,h'13,h'18,h'01,h'44,h'59
             .db h'C0,h'74,h'E8,h'8F,h'9E,h'51,h'AC,h'A6,h'C5,h'3C
             .db h'31,h'CD,h'34,h'D0,h'A0

ms_about:    .db h'6C,h'8F,h'33,h'6C,h'1F,h'50,h'2C,h'8A,h'81,h'70
             .db h'96,h'93,h'E9,h'E2,h'14,h'C7,h'E5,h'09,h'14,h'2C
             .db h'06,h'42,h'E1,h'0F,h'41,h'A5,h'29,h'E2,h'15,h'00
             .db h'93,h'C8,h'47,h'D4,h'10,h'75,h'07,h'DE,h'93,h'4C
             .db h'3A,h'75,h'38,h'43,h'D0,h'6C,h'53,h'8A,h'24,h'E7
             .db h'91,h'4B,h'D2,h'4A,h'10,h'35,h'36,h'C8,h'54,h'89
             .db h'1A,h'E1,h'1E,h'0D,h'A4,h'9B,h'23,h'CC,h'DB,h'07
             .db h'D3,h'22,h'8E,h'83,h'E7,h'93,h'22,h'D5,h'82,h'24
             .db h'53,h'65,h'18,h'B0,h'F1,h'27,h'13,h'6C,h'11,h'F8
             .db h'A1,h'1F,h'AC,h'16,h'A7,h'D3,h'C1,h'B5,h'3E,h'15
             .db h'0B,h'83,h'93,h'1F,h'85,h'18,h'E0,h'17,h'12,h'BD
             .db h'B4,h'D9,h'1E,h'66,h'D8,h'3E,h'9E,h'4F,h'44,h'C5
             .db h'E9,h'3D,h'13,h'07,h'A2,h'60,h'D0,h'A0

; Various monitor messages

ms_you:      .db h'84,h'0D,h'50,h'58,h'F2,h'24,h'4F,h'D2,h'71,h'4A
             .db h'63,h'E8,h'47,h'DE,h'4C,h'3A,h'24,h'A1,h'1F,h'8D
             .db h'71,h'A2,h'D4,h'40,h'7D,h'ED,h'A1,h'40

ms_err:      .db h'3C,h'15,h'58,h'24,h'A5,h'95,h'87,h'D3,h'C1,h'B5
             .db h'09,h'54,h'0B,h'22,h'9C,h'24,h'C9,h'D2,h'95,h'02
             .db h'25,h'82,h'89,h'CE,h'07,h'45,h'ED,h'ED,h'ED,h'A1
             .db h'40

ms_noerr:    .db h'3C,h'15,h'58,h'24,h'A5,h'95,h'9A,h'7C,h'15,h'73
             .db h'1F,h'88,h'B9,h'39,h'13,h'9C,h'0E,h'8B,h'DB,h'42
             .db h'80

ms_end:      .db h'80,h'44,h'7E,h'4E,h'C2,h'8F,h'08,h'F2,h'24,h'D9
             .db h'26,h'3E,h'89,h'F9,h'11,h'F3,h'C9,h'93,h'2E,h'28
             .db h'C4,h'FA,h'30,h'E9,h'32,h'24,h'F4,h'9A,h'14

ms_up:       .db h'34,h'C3,h'A0,h'C9,h'42,h'C0,h'D9,h'87,h'4A,h'93
             .db h'DB,h'42,h'80

ms_hello:    .db h'31,h'C5,h'18,h'A6,h'C9,h'F3,h'51,h'CB,h'8A,h'9A
             .db h'E7,h'CE,h'10,h'B8,h'39,h'58,h'24,h'9B,h'27,h'CD
             .db h'69,h'A1,h'40

ms_toobg:    .db h'B0,h'59,h'53,h'E6,h'B6,h'F0,h'4E,h'42,h'45,h'50
             .db h'04,h'F0,h'21,h'E7,h'B6,h'85,h'00
           
ms_inv:      .db h'84,h'0D,h'50,h'58,h'F2,h'24,h'4F,h'D2,h'71,h'4A
             .db h'63,h'E8,h'47,h'DE,h'4C,h'3A,h'24,h'A1,h'68,h'2C
             .db h'73,h'05,h'A9,h'39,h'ED,h'A1,h'40

ms_cut:      .db h'FF,h'FF,h'F4,h'2C,h'6D,h'50,h'49,h'C4,h'BF,h'FF
             .db h'FC,h'50

ms_start:    .db h'8D,h'63,h'AA,h'84,h'0D,h'72,h'AE,h'63,h'F1,h'17
             .db h'27,h'27,h'C2,h'05,h'E9,h'3D,h'27,h'A4,h'D0,h'A0
           
ms_math:     .db h'B0,h'49,h'31,h'F8,h'C0,h'93,h'90,h'91,h'7A,h'08
             .db h'50

ms_mne:      .db h'B0,h'59,h'50,h'91,h'4F,h'85,h'4C,h'4D,h'BE,h'4D
             .db h'83,h'E2,h'0B,h'3D,h'B4,h'28
           
ms_diss:     .db h'89,h'8C,h'16,h'2D,h'3E,h'43,h'AA,h'22,h'CE,h'22
             .db h'7C,h'FA,h'27,h'E9,h'3B,h'4F,h'90,h'EA,h'3A,h'23
             .db h'E4,h'7D,h'31,h'F8,h'50,h'58,h'24,h'E5,h'00,h'94
             .db h'2A,h'82,h'27,h'E4,h'50

ms_done:     .db h'90,h'7C,h'94,h'60,h'58,h'61,h'82,h'3E,h'79,h'A1
             .db h'40

ms_done2:    .db h'90,h'7C,h'93,h'60,h'F2,h'11,h'F3,h'CD,h'0A,h'00

ms_done3:    .db h'6A,h'41,h'F2,h'42,h'C0,h'D9,h'8C,h'70,h'8F,h'9E
             .db h'68,h'50

ms_line:     .db h'6B,h'FF,h'FD,h'A1,h'40

ms_rgs:      .db h'60,h'B2,h'DE,h'05,h'B5,h'C9,h'6B,h'82,h'77,h'5C
             .db h'4C,h'D4,h'5E,h'8A,h'D3,h'D1,h'31,h'63,h'D1,h'32
             .db h'31,h'E8,h'99,h'8B,h'2C,h'C1,h'6D,h'24,h'90,h'18
             .db h'A5,h'E8,h'98,h'A9,h'7A,h'26,h'49,h'25,h'B6,h'F9
             .db h'36,h'0F,h'88,h'2D,h'B4,h'28

ms_wertn:    .db h'65,h'47,h'49,h'91,h'AA,h'04,h'93,h'8A,h'9A,h'E7
             .db h'CA,h'5E,h'DA,h'14
             
ms_memsm:    .db h'6C,h'9B,h'07,h'42,h'A2,h'6B,h'6D,h'B1,h'D0,h'BD
             .db h'06,h'85,h'02

ms_ss_pt:    .db h'8C,h'5E,h'89,h'F0,h'A0

ms_sshlp:    .db h'31,h'C5,h'18,h'A7,h'A2,h'4F,h'04,h'8E,h'98,h'F4
             .db h'49,h'D0,h'B8,h'39,h'46,h'28,h'0C,h'A2,h'03,h'F1
             .db h'69,h'A1,h'40

ms_illmd:    .db h'10,h'E9,h'D2,h'3C,h'C3,h'A9,h'B0,h'92,h'68,h'50

ms_thank:    .db h'B0,h'58,h'FC,h'02,h'A1,h'03,h'50,h'B8,h'39,h'1B
             .db h'11,h'1F,h'3C,h'A2,h'23,h'E7,h'8E,h'97,h'1A,h'46
             .db h'26,h'C2,h'49,h'E9,h'34,h'D0,h'A0

ms_dnfl:     .db h'90,h'7C,h'90,h'B8,h'87,h'4E,h'88,h'F9,h'E6,h'85
             .db h'00

ms_dnhu:     .db h'90,h'7C,h'94,h'13,h'5F,h'A2,h'3E,h'79,h'A1,h'40
           
ms_nohu:     .db h'11,h'48,h'92,h'FB,h'D1,h'27,h'A8,h'5C,h'47,h'E5
             .db h'45,h'E8,h'A8,h'9A,h'CA,h'F6,h'D0,h'A0

; RS-232 input and output routines.  On a 4 Mhz 8085,  they run at
; 2400 baud, and on a 8 Mhz 8085, they run at 4800 baud.  'get_byte'
; gets 1 byte from the port, and 'put_byte' sends one out the port.
; The b reg holds the byte to be outputted.  Note that the DE & HL
; rp's are not changed, but the PSW and BC rp are.

;8256

;get_byte:     in h'0f
;              ani h'40
;              jz get_byte   ;wait for a byte\
;              in h'07       ;get the byte
;              mov b,a
;              ret

;put_byte:     in h'0f
;              ani h'20
;              jz put_byte   ;wait until buffer is empty
;              mov a,b
;              out h'07      ;output the byte
;              ret

;8251

;get_byte:     in h'04
;              ani h'02
;              jz get_byte
;              in h'00
;              mov b,a
;              ret

;put_byte:     in h'04
;              rar
;              jnc put_byte
;              mov a,b
;              out h'00
;              ret

;2681

get_byte:      in h'01
               ani h'01
               jz get_byte
               in h'03
               mov b,a
               ret

put_byte:      in h'01
               ani h'04
               jz put_byte
               mov a,b
               out h'03
               ret

;RIM/SIM 8085 serial port

;get_byte:    rim                    ; Wait for a start bit
             ani h'80               ; Strip all but Strt bit
             jnz get_byte           ; If not clear, keep waiting
             push d                 ; Save the DE rp
             mvi c,h'1c             ; Wait 1 bit-time

rl1:         dcr c                  ; Time- waster
             jnz rl1                ; Done waiting?
             rim                    ; Get a serial bit (Note that it's inv.)
             rlc                    ; Is the byte > 128?
             rc                     ; If so, quit
             mvi d,8                ; Setup for 8 bits
             mvi b,0                ; Zero output byte
             sub a                  ; clear the Acc.

rl2:         mvi c,h'3a             ; Set C to bit-time

rl3:         dcr c                  ; Time- waster
             jnz rl3                ; Done wasting time?
             rim                    ; Get serial bit
             ani h'80               ; Strip all but the bit
             ora b                  ; Put the bit in
             rar                    ;  the B reg.
             mov b,a                ; after rotating it.
             dcr d                  ; Last bit?
             jnz rl2                ; If not, get another bit
             ral                    ; Otherwise, re-adjust B reg, because 
             mov b,a                ;  we rotated one too many! :-)
             mvi c,h'3a             ; Wait for the stop bit before quitting

rl4:         dcr c                  ; Time- waster
             jnz rl4                ; Done wasting time?
             mvi c,1                ; Set C for 'got it O.K.!'
             pop d                  ; Get saved DE rp
             ret                    ; Return, after a job well done

;put_byte:    push d                 ; Save the DE rp
             mvi d,8                ; How many bit to send out
             mvi a,h'40             ; SIM mask
             sim                    ; Set IM, send start bit
             mvi c,h'3a             ; How long for SB?

rl5:         dcr c                  ; Time- waster
             jnz rl5                ; Enough time?

rl6:         mov a,b                ; Get a bit from
             rrc                    ;  the B
             mov b,a                ; register by rotating
             ani h'80               ; Strip off lower 7 bits
             ori h'40               ; Set SOD enable
             sim                    ; Set the IM
             mvi c,h'3a             ; Set up ctr for 1 bit time

rl7:         dcr c                  ; Time- waster
             jnz rl7                ; Enough?
             dcr d                  ; Dcr bit counter
             jnz rl6                ; All 8 bits?  If not, do it again
             mvi a,h'c0             ; Set SID for a stop bit
             sim                    ; Set IM
             mvi c,h'77             ; Set for 2 bit lengths

rl8:         dcr c                  ; Time- waster
             jnz rl8                ; Done?
             mvi a,h'8d             ; Finally, re- set SIM
             sim                    ; Do it
             pop d                  ; Get DE reg that was saved
             ret                    ; Return
;
; The following routine gets a text string from the user,
; stores it, and converts lower case to upper case.
; The 'buffer' stores the data.  The B reg hold the # of chars.

get_usr:     lxi h,buffer           ; Point to start of temp_block
             push h                 ; Save pointer
             mvi a,20               ; # of bytes

gm_loop1:    mvi m,h'20             ; Fill type
             inx h                  ; Inc pointer
             dcr a                  ; Dcr ctr
             jnz gm_loop1           ; Not zero
             sta tmp_1              ; (zero) store a 0 in char pos
             pop h                  ; Get pointer

gm_loop2:    call get_byte          ; Get a char
             push b                 ; Stuff it on stack
             call put_byte          ; Put the char
             pop b                  ; Yank off stack
             mov a,b                ; Mov byte to acc
             cpi 13                 ; Is it cr?
             jz end_line            ; Yes
             cpi 10                 ; (no) is lf?
             jz end_line            ; Yes
             cpi 8                  ; (no) is it bs?
             jz del_data            ; Yes
             mov m,a                ; (no) put it in the temp
             inx h                  ; Inc pointer
             lda tmp_1              ; Get char pos
             inr a                  ; Inc it
             sta tmp_1              ; Put it
             cpi 20                 ; Is the buffer filled?
             jz no_data             ; Yes
             jmp gm_loop2           ; (no) well, get another one!

del_data:    dcx h                  ; Dec pointer
             lda tmp_1              ; Get char pos
             dcr a                  ; Dec it
             sta tmp_1              ; Store it
             cpi h'ff               ; Is it past end?
             jnz gm_loop2           ; No
             inr a                  ; (yes) inc it
             sta tmp_1              ; Store pos (unchanged)
             inx h                  ; Inc pointer
             jmp gm_loop2           ; Go back

no_data:     mvi b,7                ; Feep the user's console
             call put_byte          ;  to alert end-of buffer.
             call get_byte          ; Get a char
             mvi a,10               ; Is it cr?
             cmp b                  ; Do the compare
             jz end_line            ; Yes
             mvi a,13               ; (no)
             cmp b                  ; Is it lf?
             jz end_line            ; Yes
             mvi a,8                ; (no)
             cmp b                  ; Is it bs?
             push psw               ; Push flags
             cz put_del             ; Yes
             pop psw                ; Get flags
             jz del_data            ; Yes
             jmp no_data            ; (no) quit

put_del:     mvi b,8                ; Set to bs
             call put_byte          ; Stuff it out rs232
             ret                    ; Quit
                                       
end_line:    call crlf              ; Put a crlf on screen
             lxi h,buffer           ; Reset pointer
             lda tmp_1              ; Get # of chars
             ora a                  ; Is it 0? 
             mvi b,0                ; Set B=0 just in case
             rz                     ; If it is, return

ucase:       push psw               ; Store # of chars
             mov a,m                ; Get byte from mem
             sbi 97                 ; Is it too small?
             jc ctu_2               ; Yes
             sbi 26                 ; (no) too big?
             jnc ctu_2              ; Yes
             mov a,m                ; (no) get clean copy of byte
             sbi 31                 ; Convert it
             mov m,a                ; Store it

ctu_2:       inx h                  ; Inc pointer
             pop psw                ; Pop counter
             dcr a                  ; Dec it
             jnz ucase              ; Is it 0? no
             lda tmp_1              ; Get # of bytes
             mov b,a                ; Mov it to B reg
             ret                    ; Quit

; Not much to say.  
; Just shows the menu!

menu:        lxi h,ms_menu          ; Point to the menu
             call dcomp             ; Decompress and show it
             jmp loop               ; We're done

; Not much to say again- just shows yet *another* menu

yet_menu:    lxi h,ms_yet           ; Point to menu
             call dcomp             ; Show it
             jmp loop               ; Quit

; Convert a hex word
; that's pointed to by HL.  The answer goes
; in DE.

get_hex:     xra a                  ; Clear out the reg
             sta tmp_1              ;  for where the answer
             sta tmp_1+1            ; goes.
             sta tmp_4              ; Set mode to 0
             mvi a,h'20             ; See if user
             cmp m                  ; didn't enter number.
             jz g_h_err             ; If he didn't, error out
             call do_hex            ; Do the actual conversion
             push h                 ; Save pointer
             lhld tmp_1             ; Get the answer
             xchg                   ; Mov it to DE
             pop h                  ; Get saved pointer
             ret                    ; We're done
                
g_h_err:     lxi h,ms_inv           ; (no) point to err message
             call dcomp             ; Send message
             pop h                  ; Don't smash stack
             jmp loop               ; Quit

get_hex2:    xra a                  ; Clear out the reg
             sta tmp_1              ;  for where the answer
             sta tmp_1+1            ; goes.
             cma                    ; Set mode
             sta tmp_4              ;  to FF
             mvi a,h'20             ; See if the user
             cmp m                  ; didn't enter a number.
             jz g_2_err             ; If he didn't, error out
             call do_hex            ; Do the actual conversion
             push h                 ; Save pointer
             lhld tmp_1             ; Get the answer
             xchg                   ; Mov it to DE
             pop h                  ; Get saved pointer
             ret                    ; We're done

g_2_err:     lxi h,ms_inv           ; (no) point to err message
             call dcomp             ; Send message
             xra a                  ; Set the
             sta tmp_4              ; error flag.
             ret                    ; Quit

do_hex:      mvi d,0                ; (no) type is hex
             lxi b,hextabl          ; Point to hex table

gh_loop:     ldax b                 ; Get byte
             cmp m                  ; Cmp to user's byte
             jz found2              ; Same? yes
             inr d                  ; (no) inc value
             inx b                  ; Inc pointer
             mov a,d                ; Mov it
             cpi 16                 ; Is it the end?
             jnz gh_loop            ; No
             mvi a,h'20             ; (yes) is it space?
             cmp m                  ; Compare
             rz                     ; Yes
             mvi a,','              ; (no) is it A ,?
             cmp m                  ; Compare
             rz                     ; Yes
             
d_h_err:     lxi h,ms_inv           ; (no) point to err message
             call dcomp             ; Send message
             jmp bail_out           ; Quit
                                      
found2:      mov a,d                ; Mov the byte
             ral                    ; >-rotate it 4 times
             ral                    ; |
             ral                    ; |
             ral                    ; >
             mvi e,4                ; # of rotations
                
big_rt:      ral                    ; Get it to the carry
             push psw               ; Save it
             lda tmp_1              ; Get byte
             ral                    ; Rotate it
             sta tmp_1              ; Put byte
             lda tmp_1+1            ; Get byte
             ral                    ; Rotate it
             sta tmp_1+1            ; Put byte
             jc too_big             ; If it carrys, it's too big
             pop psw                ; Get saved #
             mov d,a                ; Move to safe reg
             dcr e                  ; Dcr counter
             mov a,e                ; Mov it for cmp
             cpi 0                  ; Cmp it to 0
             mov a,d                ; Un-save reg
             jnz big_rt             ; Zero? no
             inx h                  ; (yes)
             jmp do_hex             ; Keep doing it

too_big:     pop psw                ; Don't smash the stack
             lxi h,ms_toobg         ; Say the number's too big
             call dcomp             ; Do it
             
bail_out:    lda tmp_4              ; If this was
             ora a                  ;  JMP'ed to,
             jz noret               ; POP the stack and goto LOOP.
             cma                    ; Otherwise,
             sta tmp_4              ;  set the error flag
             ret                    ; and return.

noret:       pop h                  ; Don't smash
             pop h                  ;  the stack!
             jmp loop               ; We're done

; Just clears the screen

clear:       mvi b,12               ; Set to clr
             call put_byte          ; Show it
             jmp loop               ; Quit

; Shows the authour, etc. ;-)

about:       lxi h,ms_about         ; Point to message
             call dcomp             ; Show it
             jmp loop               ; Quit

; Hunts thru memory for a 16-bit word

hunt:        xchg                   ; Mov it
             call get_hex           ; Get start addr
             xchg                   ; Mov it
             shld tmp_2             ; Store it
             xchg                   ; Mov it
             inx h                  ; Inc pointer
             call get_hex           ; Get end addr
             xchg                   ; Mov it
             shld tmp_3             ; Store it
             xchg                   ; Mov it
             inx h                  ; Inc pointer
             call get_hex           ; Get search word
             push d                 ; Mov it to
             pop b                  ; BC reg
             lhld tmp_3             ; Get end addr
             xchg                   ; Mov it to DE
             lhld tmp_2             ; Get start addr
             inx d                  ; Inc end
             xra a                  ; Store 0 in found/ctr
             sta tmp_4              ; Store it
                                     
hu_loop:     mov a,m                ; Try 1st
             cmp b                  ; byte.
             jnz hu_nope            ; Not the same, go on
             inx h                  ; Same; inc pointer
             mov a,m                ; Try 2nd byte
             dcx h                  ; Mov pointer back
             cmp c                  ; Compare
             jnz hu_nope            ; Not the same, go on
             push b                 ; Same, save
             push d                 ;  what we
             push h                 ; use.
             mvi b,'['              ; Show a '['
             call put_byte          ; Show it
             mov a,h                ; Show hi part of addr
             call show_one          ; Show it
             mov a,l                ; Show low part of addr
             call show_one          ; Show it
             mvi b,']'              ; Show a ']'
             call put_byte          ; And a
             mvi b,' '              ; space.
             call put_byte          ; Show it
             lda tmp_4              ; Get temp
             ori h'10               ; OR it with 10 to set 'found' flag
             inr a                  ; Inc it
             sta tmp_4              ; Store it
             cpi h'18               ; 8 addrs?
             jnz hu_nocr            ; If not, don't do anything
             call crlf              ; Show a CRLF
             mvi a,h'10             ; Store a 10
             sta tmp_4              ; in the counter

hu_nocr:     pop h                  ; Get
             pop d                  ;  saved
             pop b                  ; regs.

hu_nope:     inx h                  ; Inc pointer
             mov a,h                ; Upper addr
             cmp d                  ; same?
             jnz hu_loop            ; If not, keep doing it
             mov a,l                ; Lower addr
             cmp e                  ; same?
             jnz hu_loop            ; If not, keep doing it
             lda tmp_4              ; Get counter/flag
             ani h'10               ; Is bit set?
             jz hu_none             ; If not, show 'nothing found'
             lxi h,ms_hudn          ; Show 'done searching'
             call string            ; message.
             jmp loop               ; Quit

hu_none:     lxi h,ms_huno          ; Show the
             call string            ; 'nothing found' message
             jmp loop               ; Quit

ms_huno:     .db "NOTHING FOUND\n\r\0"       ; Messages
ms_hudn:     .db "\n\rDONE SEARCHING\n\r\0"  ; for above routine.

; Multiply two numbers              

multiply:    xchg                   ; Mov around
             call get_hex           ; Get 1st number
             xchg                   ; Mov it
             shld tmp_3             ; Store it
             xchg                   ; Mov it
             inx h                  ; Inc pointer
             call get_hex           ; Get 2nd number
             lxi h,0                ; Set lower word to 0's
             mvi b,16               ; 16 bits
                
mul_loop:    ana a                  ; Clear carry
             mov a,l                ; Do a huge 32-bit
             ral                    ; rotate
             mov l,a                ;
             mov a,h                ;
             ral                    ;
             mov h,a                ;
             mov a,e                ;
             ral                    ;
             mov e,a                ;
             mov a,d                ;
             ral                    ;
             mov d,a                ; Last bit out is value
             jnc skip_mul           ; If one, add one number to ans.
             push d                 ; Save D reg
             xchg                   ; Mov HL to DE
             lhld tmp_3             ; Get number
             dad d                  ; Add it to answer
             mvi a,0                ; Get carry
             aci 0                  ; into acc.
             pop d                  ; Get upper word of ans.
             push h                 ; Save lower word of ans.
             mov l,a                ; Mov cy flag to L
             mvi h,0                ; Set H to 0
             dad d                  ; Add it to upper word
             xchg                   ; Mov it back to DE
             pop h                  ; Get HL back

skip_mul:    dcr b                  ; Dec bit ctr
             jnz mul_loop           ; If not 0, keep doing it
             push h                 ; Save 
             push d                 ; ans.
             lxi h,ms_math          ; Show 'The answer is:'
             call dcomp             ; Show it
             pop d                  ; Get saved
             pop h                  ; ans.
             mov a,d                ; Show 
             call show_one          ;  all
             mov a,e                ;   32-bits
             call show_one          ;   of
             mov a,h                ;  the
             call show_one          ; answer.
             mov a,l                ;
             call show_one          ;
             call crlf              ; Show a CRLF
             jmp loop               ; Quit

; divide two numbers

divide:      xchg                   ; Mov it
             call get_hex           ; Get dividend
             xchg                   ; Mov it
             shld tmp_3             ; Store it
             xchg                   ; Mov it
             inx h                  ; Inc pointer
             call get_hex           ; Get divisor
             xra a                  ; Is it
             cmp d                  ; too big?
             jnz fi_bad             ; If so, tell user & quit
             cmp e                  ; Is the divisor 0?
             jz dbz                 ; If so, tell user
             mov c,e                ; Mov the divisor to C
             lhld tmp_3             ; Get dividend
             mov e,a                ; Set remainder to 0
             mvi b,16               ; Number of bits: 16
             
div_loop:    xra a                  ; Clear acc
             ora b                  ; Counter 0? If so, quit. (carry=0)
             jz  div_end            ; If so, quit
             mov a,l                ; Do a big rotate
             ral                    ;  of the dividend
             mov l,a                ; and remainder.
             mov a,h                ; 
             ral                    ; 
             mov h,a                ; 
             mov a,e                ; 
             ral                    ; 
             mov e,a                ; 
             dcr b                  ; Dec bit ctr
             cmp c                  ; CMP rem & div
             jc  div_loop           ; Rem < div? If so, keep doing it
             sub c                  ; Sub divisor from remainder
             mov e,a                ; Mov it back
             inx h                  ; Bit was a 1, set it
             jmp div_loop           ; Keep doing it

div_end:     push d                 ; Save
             push h                 ; ans.
             lxi h,ms_math          ; Show the 'answer is' message
             call dcomp             ; Do it
             pop h                  ; Get the ans
             mov a,h                ; Show the
             call show_one          ; upper byte.
             mov a,l                ; Show the
             call show_one          ; lower byte.
             mvi b,' '              ; Show a 
             call put_byte          ; space.
             mvi b,'r'              ; Show a
             call put_byte          ; 'r'.
             mvi b,' '              ; Show 
             call put_byte          ; another space.
             pop d                  ; Get saved remainder
             mov a,e                ; Mov it
             call show_one          ; Show it
             call crlf              ; Show a CRLF
             jmp loop               ; Quit

dbz:         lxi h,ms_div0          ; Show the user
             call string            ; he tried to div by 0.
             jmp loop               ; Show it

ms_div0:     .db "Divide by 0!\n\r\0"  ; The message

; Test the RAM in the system
                                    
test:        xchg                   ; Mov it
             shld tmp_3             ; Save the pointer
             lxi h,0                ; Set RAM ptr to 0
                                    
test_lp:     mov b,m                ; Save the byte
             mov a,m                ; Complement
             cma                    ;  the
             mov m,a                ; byte.
             mov a,m                ; Mov it to acc
             cmp b                  ; Same?
             mov m,b                ; Mov it back
             jnz test_hit           ; If not, we hit RAM
             inr h                  ; Inc pointer
             jnz test_lp            ; Keep doing it
             jmp loop               ; Until wrap-around, then quit
                                    
test_hit:    push h                 ; Mov HL to
             pop d                  ; DE.
             inr h                  ; Inc H so we don't false- trigger
            
th_loop:     ldax d                 ; Get byte from start of mem
             cmp h                  ; Is it the same?
             jz thl_hit             ; If so, make sure
                                    
thlh_ret:    inr h                  ; Inc pointer
             jnz th_loop            ; Wrap-around?
             jmp foldover           ; If not, keep doing it

thl_hit:     ldax d                 ; Get byte
             cma                    ; Comp acc
             stax d                 ; Store it
             mov b,m                ; Mov it to temp
             cma                    ; CMP again to fix
             stax d                 ; Store it
             cma                    ; CMP again
             cmp b                  ; Compare
             jnz thlh_ret           ; If not the same, not fold-over

foldover:    mov a,h                ; Sun to find out
             sub d                  ; How many bytes of RAM
             call show_one          ; Show it
             xra a                  ; Show a
             call show_one          ; set of 2 zeroes
             push h                 ; Save HL
             lxi h,ms_fold          ; Show the
             call string            ; RAM message.
             mov a,d                ; Show 
             call show_one          ;  the
             mov a,e                ;  start
             call show_one          ; addr.
             lxi h,cmp_dat3         ; Show the
             call string            ; ' TO ' message.
             pop h                  ; Get saved addr
             dcx h                  ; Dec it
             mov a,h                ; Show
             call show_one          ;  the
             mov a,l                ;  end
             call show_one          ; addr.
             inx h                  ; Inc it back
             push h                 ; Save it
             lhld tmp_3             ; Was it supposed
             mvi a,'1'              ;  to be a 
             cmp m                  ; thorough test?
             pop h                  ; Get saved addr
             jz fulltest            ; If so, do it
             
ft_ret:      call crlf              ; Show a CRLF
             xra a                  ; Are we
             cmp h                  ; done?
             jz loop                ; If so, quit
             jmp test_lp            ; Otherwise, keep doing it

ms_fold:     .db " BYTES OF RAM @ \0"  ; RAM message

fulltest:    push h                 ; Save addr

fut_loop:    dcx h                  ; Dec addr
             mov b,m                ; Save byte
             mvi a,h'55             ; Put a
             mov m,a                ; B'01010101 pattern into memory
             cmp m                  ; Same as memory?
             mov m,b                ; Mov it back
             jnz ft_fail            ; If not, memory chip is bad
             cma                    ; CMP for B'10101010 pattern
             mov m,a                ; Mov that into memory
             cmp m                  ; Cmp against memory
             mov m,b                ; Mov it back
             jnz ft_fail            ; IF not same, memory chip is bad
             mov a,h                ; Are we done
             cmp d                  ; yet?
             jnz fut_loop           ; If not, keep doing it
             mov a,l                ; Try lower
             cmp e                  ; byte.
             jnz fut_loop           ; Not done; keep doing it
             lxi h,ms_tok           ; Show 'memory ok'
             call string            ; Show it
             pop h                  ; Get saved addr
             jmp ft_ret             ; Quit

ft_fail:     push h                 ; Save where
             lxi h,ms_tfl           ; Show 'failed @'
             call string            ; message.
             pop h                  ; Get saved addr
             mov a,h                ; Show
             call show_one          ;  the
             mov a,l                ;  failed
             call show_one          ; addr.
             pop h                  ; Get saved addr
             jmp ft_ret             ; Quit

ms_tok:      .db " - OK!\0"         ; RAM OK mess.
ms_tfl:      .db " - FAILED @ \0"   ; RAM BAD mess.

; shoves a hex representation of the acc; saves everything except acc.

show_one:    push d                 ; Save
             push b                 ;  the junk
             push h                 ; we used.
             mov d,a                ; Save byte
             rrc                    ; Do 
             rrc                    ;  a
             rrc                    ;  nybble
             rrc                    ; swap.
             ani h'f                ; Strip upper bytes
             mov c,a                ; Mov it to C
             mvi b,0                ; SSet B to 0
             lxi h,hextabl          ; Point to HEX table
             push h                 ; Save table pointer
             dad b                  ; Adj pointer
             mov b,m                ; Get 1st byte
             call put_byte          ; Show it
             mov a,d                ; Get saved byte
             ani h'f                ; Strip off top
             mov c,a                ; Mov it to C
             mvi b,0                ; Set B to 0
             pop h                  ; Get saved table
             dad b                  ; Adj table pointer
             mov b,m                ; Get byte
             call put_byte          ; Show it
             pop h                  ; Get 
             pop b                  ;  saved
             pop d                  ; junk.
             ret                    ; Quit

; Fills a specified area of memory with a data byte

fill:        xchg                   ; Mov around
             call get_hex           ; Get the 1st addr
             xchg                   ; Mov around
             shld tmp_2             ; Store it
             xchg                   ; Mov around
             inx h                  ; Inc pointer
             call get_hex           ; Get 2nd addr
             xchg                   ; Mov around
             shld tmp_3             ; Store it
             xchg                   ; Mov around
             inx h                  ; Inc pointer
             call get_hex           ; Get fill byte
             xra a                  ; Is fill byte > H'ff?
             cmp d                  ; Do the cmp
             jnz fi_bad             ; If >0, it is; tell user off
             lhld tmp_3             ; Get the end addr
             push h                 ; Mov it to
             pop b                  ; BC.
             lhld tmp_2             ; Get start addr
             inx b                  ; Inc end

fi_loop:     mov m,e                ; Store the byte
             inx h                  ; Inc pointer
             mov a,c                ; Is the lower byte
             cmp l                  ; the same as the end?
             jnz fi_loop            ; If not, keep filling
             mov a,b                ; Try upper byte
             cmp h                  ; of addr.
             jnz fi_loop            ; If not the same, keep doing it
             lxi h,ms_dnfl          ; Show the
             call dcomp             ; 'Done filling' message
             jmp loop               ; Quit

fi_bad:      lxi h,ms_toobg         ; Show the user he entered
             call dcomp             ; a # that was too big.
             jmp loop               ; Quit



; Upload data to the
; user's console.

upload:      xchg                   ; Mov pointer to HL
             call get_hex           ; Convert the 1st num
             xchg                   ; Mov DE -> HL
             shld tmp_2             ; Store the 1st word (start)
             xchg                   ; Mov DE -> HL
             inx h                  ; Skip over seperator
             call get_hex           ; Get the 2nd word (end)
             mov a,e                ; Did the user
             ora d                  ;  forget an ending addr.?
             jz no_end              ; If so, tell him
             lhld tmp_2             ; Get 1st word
             push h                 ; Save HL (start)
             mov a,h                ; Set- up HL for a subtraction
             cma                    ;  by
             mov h,a                ;   using
             mov a,l                ;    2's
             cma                    ;   complement
             mov l,a                ;  arithmatic
             inx h                  ; method.
             dad d                  ; Do the subtraction
             push h                 ; Save it
             lxi h,ms_cut           ; Point to 'cut here' message
             call dcomp             ; Show it
             pop d                  ; Pop how many bytes
             pop h                  ; Pop start addr.
             
lineloop:    xra a                  ; Is the upper byte 0?
             cmp d                  ; Do the compare
             jnz morethan           ; If not, send 16 bytes
             cmp e                  ; Is the lower byte 0?
             jz done_up             ; If so, we're done!
             mvi a,16               ; Set for 16 bytes
             cmp e                  ; Are more than 16 bytes left?
             jc morethan            ; If so, goto more
             mov a,e                ; Set counter to number of bytes left
             jmp skip_16            ; Goto lineloop

morethan:    mvi a,16               ; Number of bytes/line
             
skip_16:     sta tmp_2+1            ; Store in bytes/line reg
             xra a                  ; Set Acc to 0
             sta tmp_2              ; Set the sumcheck reg to 0
             shld tmp_1             ; Store the address in a temp reg
             push h                 ; Save
             push d                 ;  all
             call crlf              ; show a CRLF
             mvi b,':'              ; Send out a start-of-line
             call put_byte          ;  byte.
             lxi h,tmp_2+1          ; Point to how many bytes
             call showbyte          ; Show it
             lxi h,tmp_1            ; Point to current address
             call showword          ; Show the address
             xra a                  ; Show a 00 byte
             sta tmp_1              ; Store it
             dcx h                  ; Show it
             call showbyte          ; show an empty byte
             pop d                  ; Get saved
             pop h                  ; regs.
             lda tmp_2+1            ; Add the 1st 3 bytes together
             add l                  ; Addr hi
             add h                  ; Addr lo
             sta tmp_2              ; Store it

byteloop:    push h                 ; Save the pointer & counter
             push d                 ; (Counter)
             call showbyte          ; Show the byte
             pop d                  ; Get the
             pop h                  ; saved stuff
             lda tmp_2              ; Add the
             add m                  ; byte to the
             sta tmp_2              ; sumcheck reg.
             inx h                  ; Inc pointer
             dcx d                  ; Dec counter
             lda tmp_2+1            ; Dec the
             dcr a                  ;  byte
             sta tmp_2+1            ; counter.
             jnz byteloop           ; Last byte?
             lda tmp_2              ; Get sumcheck
             cma                    ; Complement it
             inr a                  ; Inc it
             sta tmp_2              ; Store it
             push h                 ; Save Addr 
             push d                 ; and counter
             lxi h,tmp_2            ; Point to byte
             call showbyte          ; Show it
             pop d                  ; Get saved
             pop h                  ; stuff
             jmp lineloop           ; Do another line
             
done_up:     call crlf              ; Do a CRLF
             lxi h,ms_updn          ; Show the end string
             call string            ; Do it
             lxi h,ms_cut           ; Show the 'cut here' message
             call dcomp             ; Do it
             call crlf              ; Do 2
             call crlf              ; CRLF's
             jmp loop               ; We're done

ms_updn:     .db ":00000001FF\n\r\0"; End of upload ms

no_end:      lxi h,ms_end           ; Point to messsage 'give me an ending'
             call dcomp             ; Show it
             jmp loop               ; Quit

download:    xchg                   ; Mov DE -> HL
             mvi a,' '              ; Load a space into the Acc
             sta tmp_2              ; Set the 'use old addr.' reg
             sta tmp_2+1            ; Set the 'trans. error' reg
             cmp m                  ; See if there is a start addr.
             jz strt_dn             ; If not, skip getting it
             call get_hex           ; Otherwise, get the start addr.
             xchg                   ; Mov it to H/L
             shld tmp_1             ; Store it
             xra a                  ; Clear the
             sta tmp_2              ; 'use old addr.' reg. (i.e. use it!)
                                    
strt_dn:     lxi h,ms_start         ; Point to 'start transfer'
             call dcomp             ; Send it out

get_loop:    call get_byte          ; Get a byte
             mvi a,':'              ; Is it a start marker?
             cmp b                  ; Get and wait for a ':'
             jnz get_loop           ; If not, get another byte

new_line:    call get2              ; Get # of bytes
             push psw               ; and save it.
             call get2              ; Get ha addr
             mov h,a                ; Mov it
             call get2              ; Get la addr
             mov l,a                ; Mov it
             call get2              ; Throw out 00
             xra a                  ; Clear acc
             cmp h                  ; Is ha 0?
             jnz continu            ; No
             cmp l                  ; (yes) is la 0?
             jnz continu            ; No
             pop psw                ; (yes) push 'n pop
             push psw               ; for stored Acc.
             ora a                  ; Is loops 0?
             jnz continu            ; No
             pop psw                ; Throw away acc. from stack
             lda tmp_2+1            ; Were there any transfer errors?
             ora a                  ; If set, no
             jz badcodes            ; If clear, yes
             lxi h,ms_noerr         ; Exit with 'transfer done'
             call dcomp             ; Show it
             jmp loop               ; Quit

badcodes:    lxi h,ms_err           ; Point to 'riddled w/ errors!'
             call dcomp             ; Show it
             jmp loop               ; Quit
                                    
continu:     pop psw                ; Push 'n pop
             push psw               ; Get start
             add h                  ; Start getting crc
             add l                  ; Get more crc
             mov d,a                ; Mov it
             push d                 ; Push the crc counter
             lda tmp_2              ; Use old addr?
             ora a                  ; Compare
             jnz dn_loop            ; No
             lhld tmp_1             ; (yes) get the old add.

dn_loop:     call get2              ; Get a byte
             mov m,a                ; Store in memory
             pop d                  ; Pop and add
             add d                  ; Data
             mov d,a                ; To d for crc check
             inx h                  ; Inx the pointer
             pop psw                ; Pop loop ctr
             dcr a                  ; Dcr the loop ctr
             push psw               ; Store it again
             push d                 ; Store the crc counter
             jnz dn_loop            ; Is the ctr 0?
             pop d                  ; (yes) get rid
             pop psw                ; Of stack garbage
             mov a,d                ; Mov the count
             cma                    ; Complement it
             inr a                  ; Add 1    (completed crc)
             push psw               ; Push it
             call get2              ; Get block check #
             mov b,a                ; Mov it
             pop psw                ; Get calculated crc #
             cmp b                  ; Compare
             shld tmp_1             ; Store old addr.
             jz get_loop            ; Same? yes
             xra a                  ; Nope. Set error flag.
             sta tmp_2+1            ; Store error
             jmp get_loop           ; Continue getting other bytes

get2:        call get_byte          ; Get 1st byte                
             mov d,b                ; Mov it
             call get_byte          ; Get 2nd byte
             mov e,b                ; Mov it
             call cvl2hex           ; Call to cvl it
             ret                    ; Return

cvl2hex:     mov a,e                ; Get 1st byte
             sui '9'+1              ; Sub 9+1
             jnc letter1            ; If bigger, a letter
             mov a,e                ; (number) get it again
             ani h'0f               ; Strip high nybble
             mov b,a                ; Store it
             jmp skip_l1            ; If it isn't a letter, skip it
              
letter1:     adi 3                  ; It was a letter; add 3
             mov b,a                ; Store it
                
skip_l1:     mov a,d                ; Get 2nd byte to convert
             sui '9'+1              ; Sub 9+1
             jnc letter2            ; If bigger, a letter
             mov a,d                ; (number) get it again
             ani h'0f               ; Strip high nybble
             rlc                    ; >
             rlc                    ; |
             rlc                    ; |-rotate left 4 times
             rlc                    ; >
             ora b                  ; Mingle nybbles
             ret                    ; Quit

letter2:     adi 3                  ; It was a letter; add 3
             rlc                    ; >
             rlc                    ; |
             rlc                    ; |-rotate left 4 times
             rlc                    ; >
             ora b                  ; Mingle nybbles
             ret                    ; Quit


; Math does just that.  Math.
; Will add, subtract, logical or, logical and, logical xor.

math:        xchg                   ; Mov pointer to HL
             mov a,m                ; Get the operation type
             inx h                  ; Inc pointer
             sta tmp_3              ; Store the op type
             call get_hex           ; Convert the 1st num
             xchg                   ; Mov DE -> HL
             shld tmp_2             ; Store the 1st word (start)
             xchg                   ; Mov DE -> HL
             inx h                  ; Skip over seperator
             call get_hex           ; Get the 2nd word (end)
             lxi h,mathtabl         ; Point to the valid operators
             mvi c,5*2              ; Number of valid operators, *2                            

mathloop:    lda tmp_3              ; Get the user's operator
             dcr c                  ; Dec the counter
             cmp m                  ; Compare it to the valid ops
             jz math_fnd            ; If it's the same, we found it
             inx h                  ; Inc it
             dcr c                  ; Dec the counter
             jnz mathloop           ; If zero, an invalid entry
             lxi h,ms_inv           ; Point to invalid entry message
             call dcomp             ; Show it
             jmp loop               ; Quit
                                    
math_fnd:    dcr c                  ; Dec counter
             push d                 ; Save 2nd part of operator
             push b                 ; Save counter
             lxi h,ms_math          ; Point to 'the answer is'
             call dcomp             ; Show it
             pop b                  ; Get saved counter
             lxi h,mathaddr         ; Point to the sub addresses table
             mvi b,0                ; Clear upper byte
             dad b                  ; Adjust pointer
             mov d,m                ; Get upper byte
             inx h                  ; Inc pointer
             mov e,m                ; Get lower byte
             xchg                   ; Mov DE -> HL
             pop d                  ; Get 2nd operator
             pchl                   ; Show the PC to the desired operation

mathtabl:    .db "^|&-+"            ; Table w/ valid operations
                                             
mathaddr:    .dw math_add,math_sub,math_and  ; Addr.
             .dw math_or,math_xor            ; table

math_and:    lhld tmp_2             ; Get 1st word
             mov a,d                ; >
             ana h                  ; |
             mov h,a                ; |-AND 1st & 2nd words
             mov a,e                ; |
             ana l                  ; |
             mov l,a                ; >
             jmp math_end           ; Show & quit

math_or:     lhld tmp_2             ; Get 1st word
             mov a,d                ; >
             ora h                  ; |
             mov h,a                ; |-OR 1st & 2nd words
             mov a,e                ; |
             ora l                  ; |
             mov l,a                ; >
             jmp math_end           ; Show & quit

math_xor:    lhld tmp_2             ; Get 1st word
             mov a,d                ; >
             xra h                  ; |
             mov h,a                ; |-XOR 1st & 2nd words
             mov a,e                ; |
             xra l                  ; |
             mov l,a                ; >
             jmp math_end           ; Show & quit

math_sub:    mov a,d                ; >
             cma                    ; |
             mov d,a                ; |-Negate 2nd word
             mov a,e                ; |
             cma                    ; |
             mov e,a                ; |
             inx d                  ; >
             lhld tmp_2             ; Get 1st word
             dad d                  ; Do the subtraction (A-B -> -A,B)
             cmc                    ; Complement the carry
             jmp math_ad2           ; Cheat a little
                                    
math_add:    lhld tmp_2             ; Get 1st word
             dad d                  ; Do the add
             
math_ad2:    mvi a,h'30             ; Load a '0' into the acc
             aci 0                  ; Add the carry flag to it
             mov b,a                ; Mov it
             call put_byte          ; Show it

math_end:    shld tmp_1             ; Store the answer
             lxi h,tmp_1            ; Point to the answer
             call showword          ; Show it
             call crlf              ; Do a CRLF
             jmp loop               ; Quit


; This part of code takes the user's mnemonics and turns them
; into op-codes.  Not much more to say!



assemble:    xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             shld tmp_3             ; Store it

asmloop:     lhld tmp_3             ; Get the saved asm address
             lxi h,tmp_3            ; Point to it
             call showword          ; Show it
             mvi b,':'              ; Show a
             call put_byte          ;  colon.
             mvi a,3                ; Show 3 spaces     
             call space             ; Do it
             call get_usr           ; Get a line of input
             mov a,b                ; Is it just
             ora a                  ;  a CRLF?
             jz done_asm            ; If so, we're done
             lxi h,buffer           ; Point to user's input
             lxi d,0                ; Clear the 2nd buffer
             push d                 ; Save info
             
find_mne:    mvi d,10               ; Num chars
             lxi h,buffer2          ; Point to buffer 2
             
fme_loop:    mvi m,0                ; Fill with 0
             inx h                  ; Inc pointer
             dcr d                  ; Dec ctr
             jnz fme_loop           ; More?  If so, keep doing it
             pop d                  ; Get saved info
             mov a,d                ; Mov curr char to a temp pos.
             sta tmp_4+1            ; Store it
             mov a,e                ; Is it the 1st run?
             ora a                  ; If so, don't compare
             jz skip_1st            ; If 0, jmp
             mov a,d                ; Is the ctr 0?
             ora a                  ; Find out
             jz end_codes           ; If so, it was invalid
             
skip_1st:    dcr d                  ; Dec the ins. ctr
             mvi e,h'ff             ; Set to not the 1st time
             push d                 ; Save them
             lxi d,buffer2          ; Point to temp buffer
             lxi h,tmp_4+1          ; Point to where to get byte
             push d                 ; Save the temp lcn.
             call docode            ; Get the mnemonic
             pop d                  ; Get saved lcn.
             lxi h,buffer           ; Point to user's buffer

sieve:       ldax d                 ; If the char is 0, we found the
             ora a                  ;  correct mnemonic.
             jz found_it            ; If so, we found it
             cmp m                  ; Compare the 2 buffers
             jnz find_mne           ; If not the same, try again
             inx d                  ; otherwise inc both
             inx h                  ;  pointers.
             jmp sieve              ; Try the next char
                                    
found_it:    pop d                  ; Get the saved op-code
             inr d                  ; Inc to get proper op-code
             mov c,d                ; Mov op-code to a safe reg
             mov a,b                ; Check the
             ora a                  ;  mode.
             jz mode_0              ; If it's a 1-byte ins.; go here
             push psw               ; Save the mode
             push b                 ; Save the op-code
             call get_hex2          ; Get the byte or word in the ins.
             xchg                   ; Mov it to H/L
             lda tmp_4              ; Was it too big?
             ora a                  ; If 0, it was
             pop b                  ; Get saved stuff
             jz asm_error           ; Err? If so, jmp
             pop psw                ; Get saved mode
             dcr a                  ; is it a 1?
             jz mode_1              ; If so, jmp
             xchg                   ; Mov HL->DE
             lhld tmp_3             ; It's a 2-byte ins.
             mov m,c                ; Store the op-code
             inx h                  ; Inc addr.
             mov m,e                ; Store the low-order addr
             inx h                  ; Inc addr.
             mov m,d                ; Store the high-order addr
             inx h                  ; Inc addr.
             shld tmp_3             ; Store it back in the tmp lcn.
             jmp asmloop            ; Do it again
             
mode_1:      xra a                  ; Is the # bigger than h'ff?
             cmp h                  ; Do the cmp
             jnz asm_tb             ; If so, say it's too big
             mov d,l                ; Save the ins. byte
             lhld tmp_3             ; Get asm. addr
             mov m,c                ; Save the op-code
             inx h                  ; Inc the addr
             mov m,d                ; Save the byte
             inx h                  ; Inc the addr
             shld tmp_3             ; Store the asm addr
             jmp asmloop            ; Get another mnemonic

mode_0:      lhld tmp_3             ; Get the asm addr
             mov m,d                ; Save the op-code
             inx h                  ; Inc the addr.
             shld tmp_3             ; Save the asm addr
             jmp asmloop            ; Get another mnemonic

end_codes:   lxi h,ms_mne           ; Show the user he entered
             call dcomp             ;  an invalid mnemonic.
             jmp asmloop            ; Get the mnemonic again

done_asm:    call crlf              ; Show a crlf
             jmp loop               ; Quit

asm_error:   pop h                  ; Don't smash the stack!
             jmp asmloop            ; Get another mnemonic

asm_tb:      lxi h,ms_toobg         ; Show the user that the
             call dcomp             ;  number was too big.
             jmp asmloop            ; Get another mnemonic

; Disassembles to the screen starting at
; the address specified by the user.

disasm:      xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             mvi b,16               ; Setup for 16 lines
                                    
dis_loop:    mov a,b                ; Mov b to a
             call disloop           ; Disasm 'b' lines
             push h                 ; Save the disasm addr
             lxi h,ms_diss          ; Point to 'more?' mess
             call dcomp             ; Show it
             call get_byte          ; Get a char
             push b                 ; Save the byte
             call dis_del           ; Delete the message
             pop b                  ; Get saved byte                  
             mov a,b                ; Mov it so we can compare
             mvi b,16               ; Set for 16 lines
             pop h                  ; If it was enter,
             cpi '\r'               ;  set
             cz set_to_1            ;   for
             jz dis_loop            ;   just
             cpi '\n'               ;   one
             cz set_to_1            ;  line only.
             jz dis_loop            ; Do it 
             cpi ' '                ; Otherwise,
             jz dis_loop            ; Show 16 lines
             jmp loop               ; Not space?  Then quit

set_to_1:    mvi b,1                ; Set for 1
             ret                    ; line.

dis_del:     mvi h,58               ; Set up for 58 chars to delete
             
dd_loop:     mvi b,8                ; Set to 'del' char
             call put_byte          ; Show it
             dcr h                  ; Dec counter
             jnz dd_loop            ; If not 0, keep doing it
             ret                    ; Quit

; Shows a memory dump starting at X, going to Y

dump:        xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             shld tmp_3             ; Store the start addr
             xchg                   ; Mov DE->HL
             inx h                  ; Inc pointer
             call get_hex           ; Get the 2nd addr.
             push d                 ; Save 
             push h                 ;  both addresses
             lxi h,ms_cut           ; Show the 'cut here' mess.
             call dcomp             ; Show it
             call crlf              ; Show a CRLF
             pop h                  ; Get
             pop d                  ;  saved stuff

new_ln:      xchg                   ; Store the
             shld tmp_2             ; end addr.
             xchg                   ; Mov DE->HL
             lhld tmp_3             ; Point to the start lcn.
             mov a,h                ; Is the start addr
             cmp d                  ;  equal to
             jnz nope_ln            ;   the
             mov a,l                ;  end
             cmp e                  ; addr?
             jnz nope_ln            ; If so, continue on,
             jmp that_all           ;  else quit.

nope_ln:     lxi h,tmp_3            ; Show the start addr.
             call showword          ; Show it
             mvi b,':'              ; Show a colon
             call put_byte          ; Do it
             mvi a,3                ; Show 3
             call space             ;  spaces.
             mvi b,16               ; Set up for 16 bytes
             
dl_loop:     lhld tmp_2             ; Compare 
             xchg                   ;  the
             lhld tmp_3             ;   start 
             mov a,h                ;    and
             cmp d                  ;     end
             jnz not_thr            ;    addresses
             mov a,l                ;   to 
             cmp e                  ;  see if they
             jnz not_thr            ; match.
             call crlf              ; Show a CRLF

that_all:    lxi h,ms_cut           ; Show the 'cut here' message
             call dcomp             ; Do it
             call crlf              ; Show a CRLF
             jmp loop               ; Quit

not_thr:     push b                 ; Save the counter
             lhld tmp_3             ; Get the current counter
             call showbyte          ; Show it
             mvi a,1                ; Show a space
             call space             ; Do it
             pop b                  ; Get the counter 
             mov a,b                ; Mov it
             cpi 9                  ; Is it 8?
             push b                 ; Save the counter
             cz show_mns            ; If so, show a '-'
             mvi a,1                ; Show another
             call space             ;  space.
             shld tmp_3             ; Save it
             pop b                  ; Pop the counter
             dcr b                  ; And dec it
             jnz dl_loop            ; If not 0, keep doing it
             call crlf              ; Otherwise, show a CRLF and
             jmp new_ln             ; Get the next line

show_mns:    mvi b,'-'              ; Show a seperator for
             jmp put_byte           ; a 8-byte marker


; Shows a hex/ASCII dump starting at X to Y


ascdump:     xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             shld tmp_3             ; Store the start addr
             xchg                   ; Mov DE->HL
             inx h                  ; Inc pointer
             call get_hex           ; Get the 2nd addr.
             xchg                   ; Mov DE->HL
             shld tmp_2             ; Save it

asc_line:    lhld tmp_2             ; Get the end addr
             xchg                   ; Mov it to DE
             lhld tmp_3             ; Get the start addr
             shld tmp_1             ; Save it fir the 2nd part
             mov a,h                ; Compare 
             cmp d                  ;  the
             jnz next_prt           ;   start
             mov a,l                ;   and
             cmp e                  ;  end
             jnz next_prt           ; addrs.
             call crlf              ; If equal, we're done
             jmp loop               ; Quit                    

next_prt:    lxi h,tmp_3            ; Show the start addr.
             call showword          ; Show it
             mvi b,':'              ; Show a colon
             call put_byte          ; Do it
             mvi a,3                ; Show 3
             call space             ;  spaces.
             mvi b,8                ; Set for 8 bytes
                                    
as_loop1:    lhld tmp_2             ; Get the end addr
             xchg                   ; Mov it
             lhld tmp_3             ; Get the start addr
             mov a,h                ; Are 
             cmp d                  ;  the
             jnz as_cont1           ;   two
             mov a,l                ;   addrs
             cmp e                  ;  the
             jnz as_cont1           ; same?

asl_loop:    push b                 ; If so, fill the
             lxi h,ms_blank         ;  rest of the
             call string            ;  space with
             pop b                  ; a '--  '.
             dcr b                  ; Keep doing it
             jnz asl_loop           ; Until done
             jmp as_cont2           ; Show the next part
                                    
as_cont1:    push b                 ; Save the counter
             lhld tmp_3             ; Get the addr
             call showbyte          ; Show the byte
             shld tmp_3             ; Save the addr
             mvi a,2                ; Show 2
             call space             ; spaces.
             pop b                  ; Get the saved ctr
             dcr b                  ; Dec the ctr
             jnz as_loop1           ; Show another byte

as_cont2:    lxi h,ms_assp          ; Show the divider
             call string            ; Do it
             mvi b,8                ; Set for 8 bytes

as_loop2:    lhld tmp_2             ; Get the end addr
             xchg                   ; Mov it
             lhld tmp_1             ; Get the start addr
             mov a,h                ; Are
             cmp d                  ;  the
             jnz as2_loop           ;   two
             mov a,l                ;   addrs
             cmp e                  ;  the
             jnz as2_loop           ; same?
             call crlf              ; If so, we're done
             jmp as_done            ; w/ the current line.

as2_loop:    push b                 ; Save the ctr
             lhld tmp_1             ; Get the addr
             mov a,m                ; Get the byte
             inx h                  ; Inc the pointer
             shld tmp_1             ; Save it
             cpi 32                 ; If it's a ctrl
             cc set_dot             ;  character, then
             mov b,a                ; set to a '.'.
             call put_byte          ; Show the byte
             pop b                  ; Get the saved ctr
             dcr b                  ; Dec it
             jnz as_loop2           ; If it isn't the last one, keep doing it
             call crlf              ; Show a CRLF

as_done:     jmp asc_line           ; Get another line

set_dot:     mvi a,'.'              ; Set to a '.'
             ret                    ; Quit

ms_blank:    .db "--  \0"           ; Set unused bytes to '--  '

ms_assp:     .db "*-*  \0"          ; Divider

; Slurps a byte from the specified port

indata:      xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             xra a                  ; If the number is over
             cmp h                  ; h'ff, then
             jnz too_big2           ; Show the user & quit.
             mvi a,h'db             ; Op-code for 'IN'
             sta tmp_1              ; Store it
             mvi h,h'c9             ; Op-code for 'RET'
             shld tmp_1+1           ; Store the pair
             lxi h,get_dat          ; Show the 'IN port#' mess.
             call string            ; Do it
             lxi h,tmp_1+1          ; Point to the port#
             call showbyte          ; Show it
             lxi h,get_dat2         ; Show the '-->' message
             call string            ; Do it
             call tmp_1             ; Do the actual 'IN'
             lxi h,tmp_1            ; Point to a temp pos.
             mov m,a                ; Mov the result
             call showbyte          ; Show it
             call crlf              ; Do a CRLF
             jmp loop               ; Quit

get_dat:     .db "IN PORT#\0"       ; In from port message

get_dat2:    .db "-->\0"            ; Aarow for IFP mess.

; Shoves a byte out the specified port

outdata:     xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             xra a                  ; If it's
             cmp h                  ;  >h'ff, inform the user
             jnz too_big2           ; he made a mistake.
             shld tmp_3             ; Store the start addr
             xchg                   ; Mov DE->HL
             inx h                  ; Inc pointer
             call get_hex           ; Get the 2nd addr.
             xra a                  ; If it's
             cmp d                  ;  >h'ff, inform the user
             jnz too_big2           ; he made a mistake.
             lhld tmp_3             ; Get the port #
             mov h,l                ; Mov it
             mvi l,h'd3             ; Set to the 'OUT' op-code
             shld tmp_1             ; Store the 2 bytes
             mvi a,h'c9             ; Set to the 'RET' op-code
             sta tmp_2              ; Store it
             push d                 ; Save the data byte to go out
             lxi h,put_dat          ; Put the 'out #' mess
             call string            ; Do it
             lxi h,tmp_1+1          ; Point to the port #
             call showbyte          ; Show it
             lxi h,put_dat2         ; Show '<--' mess
             call string            ; Do it
             pop d                  ; Pop the data byte
             mov a,e                ; Mov it
             call tmp_1             ; Do the actual out
             lxi h,tmp_1            ; Point to a tmp location
             mov m,a                ; Mov the a->m
             call showbyte          ; Show it
             call crlf              ; Show a CRLF
             jmp loop               ; Quit

put_dat:     .db "OUT PORT#\0"      ; Out to port message
                                  
put_dat2:    .db "<--\0"            ; Aarow for OTP mess.

too_big2:    lxi h,ms_toobg         ; Point to the 'number too big' mess
             call dcomp             ; Show it
             jmp loop               ; Quit

; Does an ASCII entry mode

ascedit:     xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             push h                 ; Save the addr.

ascii3:      shld tmp_1             ; Store the addr so we can
             lxi h,tmp_1            ;  shove it
             call showword          ; out the RS-232 port.
             mvi b,':'              ; Show a
             call put_byte          ; colon as a seperator.
             xra a                  ; Set the # of bytes to 0
             sta tmp_2              ; Set it
             pop h                  ; Pop the saved addr.

ascii_lp:    call get_byte          ; Get a char from the user
             mov a,b                ; Is it 
             cpi 10                 ;  a
             push psw               ;   CR
             cz crlf                ;    or
             pop psw                ;     LF?
             jz loop                ;      If 
             cpi 13                 ;     so,
             push psw               ;    then 
             cz crlf                ;   we're  
             pop psw                ;  done  
             jz loop                ; and quit.      
             cpi 8                  ; Is it a BS?
             jz ascii_dl            ; If so, delete a char.
             cpi h'1f               ; Is it a ctrl char?
             jc ascii_lp            ; If so, get another char
             mov m,a                ; Otherwise, store the byte
             inx h                  ;  and inc the pointer.
             call put_byte          ; Show the byte
             lda tmp_2              ; Inc the
             inr a                  ;  byte
             sta tmp_2              ; ctr.
             cpi h'20               ; Is it up to 32 chars?
             jnz ascii_lp           ; If not, keep getting chars
             call crlf              ; Show a CRLF
             push h                 ; Save the addr
             jmp ascii3             ; Get another line

ascii_dl:    lda tmp_2              ; Dec the
             dcr a                  ;  char ctr
             sta tmp_2              ; and re-store it.
             cpi h'ff               ; Is it the begining of the line?
             jz ascii_ps            ; If so, re-set the ctr
             dcx h                  ; Dec the pointer
             mvi b,8                ; And show a
             call put_byte          ;  BS.
             jmp ascii_lp           ; Get another char

ascii_ps:    xra a                  ; Set the char ptr to 0
             sta tmp_2              ; Store it
             jmp ascii_lp           ; Get another char

; Does a plain hex-edit on the specified address

edit:        xchg                   ; Get the 
             call get_hex           ;  start
             xchg                   ; addr?
             push h                 ; Save it

pest3:       shld tmp_1             ; Save it
             lxi h,tmp_1            ; Point to the addr
             call showword          ; Show it
             mvi b,':'              ; Show a ':'
             call put_byte          ; Do it
             xra a                  ; Set the byte ctr to 0
             sta tmp_2              ; Set it

pest:        mvi a,3                ; Show 3 
             call space             ;  spaces.
             pop h                  ; Get the saved pointer
             shld tmp_1             ; Store it

pest2:       call showbyte          ; Show the byte
             dcx h                  ; Dec the inc'd pointer (by 'showbyte')

peloop:      call get_byte          ; Get a user's nybble
             mov a,b                ; Mov it to A
             cpi 10                 ; Is 
             push psw               ;  the
             cz crlf                ;   byte
             pop psw                ;    a
             jz loop                ;     CR
             cpi 13                 ;     or
             push psw               ;    LF?
             cz crlf                ;   If
             pop psw                ;  so,
             jz loop                ; Quit
             cpi h'20               ; Is it a space?
             jz pe_next             ; If so, jmp
             lxi h,hextabl          ; Point to the hex-table
             mvi c,0                ; Set the byte ctr to 0

peloop2:     mov a,m                ; If the user's input matches
             cmp b                  ; the table, get the value
             jz peloop4             ; We found it; jmp
             inx h                  ; Inc the table lcn
             inr c                  ; Inc the byte ctr
             mov a,c                ; Check to see if
             cpi h'21               ; the ctr has expired.
             jnz peloop2            ; If not, keep counting
             jmp peloop             ; Otherwise the user's input was invalid
            
pe_next:     lhld tmp_1             ; Get saved addr
             inx h                  ; Inc it
             push h                 ; Save it
             lda tmp_2              ; Inc 
             inr a                  ;  the
             sta tmp_2              ; byte ctr.
             cpi 8                  ; 8 bytes?
             jnz pest               ; If not, keep getting bytes
             call crlf              ; Show a CRLF
             jmp pest3              ; Show another line

peloop4:     lhld tmp_1             ; Get the byte pointer
             mov a,c                ; Get the tmp byte
             ani h'f                ; Rotate
             mov c,a                ;  it
             mov a,m                ;   and
             rlc                    ;    adjust
             rlc                    ;     it
             rlc                    ;      to 
             rlc                    ;       show
             ani h'f0               ;       '0X'
             ora c                  ;      to 
             mov m,a                ;     the
             mvi b,8                ;    console
             call put_byte          ;   while
             mvi b,8                ;  moving back
             call put_byte          ; two bytes.
             jmp pest2              ; Return

; Not much to say... just shows the
; auxilliary menu.

more:        lxi h,ms_more          ; Point to the more menu
             call dcomp             ; Show it
             jmp loop               ; Quit

cheat_4:     xchg                   ; Get the 
             call get_hex           ; 1st address.
             inx h                  ; Point to next entry
             xchg                   ; Store  
             shld tmp_3             ; it. 
             xchg                   ; Get the
             call get_hex           ; 2nd address.
             inx h                  ; Point to next entry
             xchg                   ; Store
             shld tmp_2             ; it.
             xchg                   ; Get the
             call get_hex           ; 3rd address.
             xchg                   ; Mov it to HL
             push h                 ; Save it
             lhld tmp_2             ; Mov the values around
             push h                 ;  so that
             lhld tmp_3             ;   B holds the start add.
             push h                 ;    D holds the end add.
             pop b                  ;    and H holds 
             pop d                  ;   the destination 
             pop h                  ;  address.
             ret                    ; Return

cheat_5:     mov a,b                ; Compare the start (counter)
             cmp d                  ;  address
             rnz                    ;   to the
             mov a,c                ;    end address. If
             cmp e                  ;     they are the same,
             rnz                    ;     show 'done'
             lhld tmp_3             ;    message
             call dcomp             ;   and
             pop h                  ;  quit, not forgetting to break out
             jmp loop               ; of the return.

; Swaps two blocks of memory

swap:        call cheat_4           ; Get the addresses
             push h                 ; Save value
             lxi h,ms_done          ; Set to
             shld tmp_3             ; swap message.
             pop h                  ; Pop saved value

sw_loop:     call cheat_5           ; Done? If so, go back to loop
             ldax b                 ; Get a byte from block 1
             push psw               ; Save it.
             mov a,m                ; Mov a byte from block 2
             stax b                 ; to block 1
             pop psw                ; Get saved block 1
             mov m,a                ; Store it in block 2
             inx h                  ; Inc both
             inx b                  ;  block pointers
             jmp sw_loop            ; and keep doing it.

; Movs a block of memory

move:        call cheat_4           ; Get the addresses
             push h                 ; Save value
             lxi h,ms_done2         ; Set to
             shld tmp_3             ; mov message.
             pop h                  ; Pop saved value

mv_loop:     call cheat_5           ; Done?  If so, go back to loop
             ldax b                 ; Get byte from block 1
             mov m,a                ; Put it in block 2
             inx h                  ; Inc source &
             inx b                  ; destination counters.
             jmp mv_loop            ; Keep doing it
             
; Compares two blocks of memory
; and reports anomalies.

compare:     call cheat_4           ; Get the addresses
             xra a                  ; Set the anomaly 
             sta tmp_1              ; counter to zero.
             push h                 ; Save value
             lxi h,ms_done3         ; Set to
             shld tmp_3             ; Comp message.
             pop h                  ; Pop saved value

co_loop:     call cheat_5           ; Done?  If so, go back to loop
             ldax b                 ; Get byte from block 1
             cmp m                  ; Compare to byte in block 2
             cnz anomaly            ; If not the same, report it
             inx h                  ; Otherwise, inc source &
             inx b                  ; destination counters.
             jmp co_loop            ; Keep doing it

anomaly:     push h                 ; Save all
             push d                 ;  three
             push b                 ; pairs.
             mvi b,'['              ; Show a
             call put_byte          ;  '['.
             pop b                  ;   Get the 
             pop d                  ;    address 
             push d                 ;     where
             push b                 ;      the
             push b                 ;     anomaly
             pop h                  ;    occured
             shld tmp_2             ;   and
             lxi h,tmp_2            ;  show
             call showword          ; it.
             mvi b,':'              ; Show a 
             call put_byte          ; colon.
             pop b                  ; Get the 
             push b                 ;  1st 
             ldax b                 ;   byte 
             sta tmp_2              ;   and
             lxi h,tmp_2            ;  show
             call showbyte          ; it.
             mvi b,'*'              ; Show an
             call put_byte          ; asterisk.
             pop b                  ; Pop
             pop d                  ;  'n
             pop h                  ;    push
             push h                 ;    all the values
             push d                 ;   just to get
             push b                 ;  the 2nd
             mov a,m                ; byte.
             sta tmp_2              ; Save it 
             lxi h,tmp_2            ; Show
             call showbyte          ; it.
             mvi b,']'              ; Show a
             call put_byte          ; ']'.
             mvi a,2                ; Show
             call space             ; 2 spaces.
             lda tmp_1              ; Inc the
             inr a                  ; anomaly
             sta tmp_1              ; counter.
             cpi 5                  ; Is it 5?
             jnz no_crlf            ; If not, don't show a CRLF
             call crlf              ; Show a CRLF
             xra a                  ; Reset
             sta tmp_1              ; the counter.

no_crlf:     pop b                  ; Get the
             pop d                  ;  saved
             pop h                  ; counters.
             ret                    ; Keep doing it

; Displays what type of memory is in the address space.

what:        call crlf              ; Do a CRLF
             lxi h,ms_memsm         ; Show the
             call dcomp             ; 'memory summary' line.
             mvi a,7                ; Draw 7 
             call space             ; spaces.
             lxi h,hextabl          ; Point to the hex table (0-F)
             
w_h_loop:    mov b,m                ; Display 0-F
             call put_byte          ;  with
             mvi a,2                ;   2 spaces
             call space             ;   between
             inx h                  ;  each.
             mov a,m                ; Have we wrapped
             cpi '0'                ; around to 0?
             jnz w_h_loop           ; No, keep printing them
             call crlf              ; Yes, show a CRLF
             mvi d,57               ; Draw 57 '-'s

w_h_loo2:    mvi b,'-'              ; Do the
             call put_byte          ;  dash
             dcr d                  ; drawing.
             jnz w_h_loo2           ; Done? No, keep doing it
             lxi h,0                ; Set the memory position &
             shld tmp_4             ; fill type char ctr to zero.

w_loop:      call cheat_6           ; See if it's writeable
             jz w_ram               ; If the same, it's RAM
             mvi l,0                ; Else it's something else. Make sure L=0

w_l_loop:    inr l                  ; Count thru memory.
             jz w_mt                ; If l=0, we're done and this block is MT
             mov a,l                ; Compare to see if MEM=L reg.
             cmp m                  ; If the same, block is empty.
             jz w_l_loop            ; Yes it's empty
             mvi l,0                ; No it's not.  Set L back to 0

w_l_l_loop:  inr l                  ; Count thru memory.
             jz w_fill              ; If 0, we're done & block is filled
             mov a,b                ; Compare MEM to saved byte
             cmp m                  ; Do the compare.
             jz w_l_l_loop          ; If same, mem is filled.
             mvi l,0                ; Otherwise, reset L again. It's ROM
             mvi a,3                ; Store type of 'ROM' in 
             sta tmp_3              ; tmp reg.
             mvi d,1                ; Set the # of blocks to 1
             push h                 ; Save the address

w_o_loop:    inr h                  ; Inc the upper address 
             mvi l,0                ; Set L to zero
             call cheat_6           ; See if it's writeable
             jz w_fall              ; If it is, we're done.
             
w_m_loop:    inr l                  ; At zero?
             jz w_fall              ; If so, we're done.
             mov a,l                ; See if this block is
             cmp m                  ; empty.
             jz w_m_loop            ; Yep. Keep checking
             mvi l,0                ; Nope.  Set L back to 0

w_m_l_loop:  inr l                  ; At zero?
             jz w_fall              ; If so, we're done.
             mov a,b                ; Check to
             cmp m                  ; see if this block is filled.
             jz w_m_l_loop          ; Yep. Keep checking
             inr d                  ; Nope. Inc the ROM block count
             jmp w_o_loop           ; Keep checking
             
w_fall:      pop h                  ; Get saved mem pointer
             mov b,d                ; Mov the block # around.
             jmp w_show             ; Show our result

w_ram:       mvi l,0                ; Reset L to zero again
             mvi a,2                ; Store type of 'RAM'
             sta tmp_3              ; in tmp reg.
             push h                 ; Save the mem counter
             mvi d,0                ; Set block counter to 0
            
w_r_loop:    inr h                  ; Inc both block pointer and
             inr d                  ; block counter
             call cheat_6           ; See if it's writeable
             jz w_r_loop            ; See if RAM.  If so, keep doing it
             pop h                  ; Get saved mem counter
             mov b,d                ; Mov around
             jmp w_show             ; Show the result

w_mt:        mvi a,1                ; Store type of 'EMPTY'
             sta tmp_3              ; in tmp reg.
             jmp w_cheat            ; Cheat a little

w_fill:      xra a                  ; Store type of 'FILL'
             sta tmp_3              ; in tmp reg.
             
w_cheat:     mvi l,0                ; Reset L to zero
             mvi b,1                ; Set block counter to 1
             push h                 ; Save mem counter
             push h                 ;  and mov it
             pop d                  ; over to B.
             inr d                  ; Inc the D reg.

w_c_loop:    call bcomp             ; See if correct
             ora a                  ; Fill or empty?
             jz w_c_end             ; If not, end
             inr d                  ; 256 blocks?
             jz w_c_end             ; If so, end.
             inr b                  ; Inc block ctr.
             jmp w_c_loop           ; Keep doing it

w_c_end:     pop h                  ; Get saved mem counter
             jmp w_show             ; Show the result

bcomp:       push h                 ; Save both
             push d                 ; pointers.

bcomp_l:     ldax d                 ; Compare
             cmp m                  ; the two blocks.
             jnz bc_fail            ; Not the same, then that's it
             inx h                  ; Otherwise, keep trying
             inx d                  ; Inc both pointers.
             mov a,l                ; Is the L reg 0?
             ora a                  ; If so, we're done.
             jnz bcomp_l            ; 0?  No, keep doing it
             dcr a                  ; Otherwise, set a to FF
             pop d                  ; And get saved 
             pop h                  ; values
             ret                    ; and quit.
                                    
bc_fail:     xra a                  ; We failed, so set acc to 0.
             pop d                  ; Get saved
             pop h                  ; values
             ret                    ; and return.

cheat_6:     mov b,m                ; Get byte and store
             mov a,m                ; it in both the A & B regs.
             cma                    ; compliment A
             mov c,a                ; Mov it to C
             mov m,a                ; Mov it to A
             mov a,m                ; And get the result back in A. (If the
             mov m,b                ; memory is RAM, it will be the same).
             cmp c                  ; Compare the memory to the test value
             ret                    ; Quit

w_show:      lda tmp_3              ; Get the type.
             
w_s_skip:    rlc                    ; Multiply by 2 to get offset
             push h                 ; Save the mem counter
             lxi h,int_table        ; Point to the table containing the mes.
             mov e,a                ; Adjust
             mvi d,0                ;  the pointer
             dad d                  ; to the correct entry.
             mov d,m                ; Load the pointed-to
             inx h                  ;  address
             mov e,m                ;   into
             xchg                   ;  HL and
             shld tmp_3             ; store it.
             pop h                  ; Get saved mem counter
             mvi a,2                ; Put a 2
             sta tmp_4              ; in tmp to point to 3rd byte of fill type
             mov a,b                ; Compare the
             ora a                  ; block ctr to 0.
             jz w_s_end             ; If it is, we're done.
             dcr a                  ; Dec block ctr.
             jz w_2_byte            ; There's 1 block left. Finish up
             dcr a                  ; Dec block ctr again
             sta tmp_4+1            ; Store it
             push h                 ; Save mem ctr
             lhld tmp_3             ; Get 2
             mov d,m                ;  bytes
             inx h                  ;  of
             mov e,m                ; fill type.
             pop h                  ; Get saved addr counter
             mvi a,h'f              ; At end 
             ana h                  ;  of 4K
             cpi h'f                ; page?
             cz w_s_1st             ; If so, set last byte to a space
             mvi b,'['              ; put a '[' on front
             call w_s               ; Show the whole mess
             lda tmp_4+1            ; Get saved block ctr
             ora a                  ; Is it 0?
             jz w_s_not             ; If so, go here to wrap up

w_s_loop:    call w_s_2             ; Get a fill type byte
             mov b,d                ; Mov it on over
             call w_s_2             ; Get another              
             mov c,d                ; Mov it on over also
             mvi a,h'f              ; Are we
             ana h                  ;  at
             cpi h'f                ; a 4K page boundry?
             jz w_set_s             ; If so, take care of it.
             call w_s_2             ; Else get another fill type byte
             mov e,d                ; and mov it over.
             
w_s_ret:     mov d,c                ; Adjust for showing
             call w_s               ; Show all 3 bytes
             lda tmp_4+1            ; Dec the block ctr
             dcr a                  ;  by
             sta tmp_4+1            ; one.
             jnz w_s_loop           ; If not 0, keep doing it
             
w_s_not:     call w_s_2             ; We're done, so get last fill type byte
             mov b,d                ; Mov it on over
             mvi d,']'              ; Put a ']' to finish off the end
             mvi e,' '              ; And a space also
             call w_s               ; Show them
             jmp w_s_end            ; That's it.  Get another fill type.
                                    
w_s_1st:     mvi e,' '              ; Store a space at the end
             mvi a,1                ; Set tmp 4 
             sta tmp_4              ; to 1. to point to 2nd byte in fill type
             ret                    ; Quit

w_set_s:     mvi e,' '              ; Set end to a space
             jmp w_s_ret            ; Go back

w_s_2:       push h                 ; Save mem ctr
             lhld tmp_3             ; Get fill addr pointer
             lda tmp_4              ; Get fill chr ctr
             mvi d,0                ; Add both
             mov e,a                ;  together
             dad d                  ; and put in HL.
             lda tmp_4              ; Inc the 
             inr a                  ;  fill 
             sta tmp_4              ; ctr.
             xra a                  ; Compare
             cmp m                  ; memory to 0. (end of fill message)
             cz w_s_rst             ; If so, reset it
             mov d,m                ; Get fill type byte
             pop h                  ; Get saved addr counter
             ret                    ; Go back

w_s_rst:     inr a                  ; Set fill chr ctr
             sta tmp_4              ; to 1.
             lhld tmp_3             ; Point HL to 1st fill type chr
             ret                    ; Go back

w_2_byte:    push h                 ; Save mem ctr
             lhld tmp_3             ; Get fill type chr ctr
             mov b,m                ; Get 2
             inx h                  ;  bytes
             mov d,m                ; of the fill type.
             pop h                  ; Get saved addr.
             mvi e,' '              ; Mov a space to 3rd fill type space
             call w_s               ; Show it
             jmp w_s_end            ; Keep doing the summary


w_s:         mvi a,h'f              ; See if we're at end of 
             ana h                  ; a 4K page: i.e. CF00.
             push d                 ; Save both
             push b                 ; pairs.
             cz w_show_a            ; If at a page boundry, show new addr.
             pop b                  ; Get both
             pop d                  ; pairs.
             call put_byte          ; Show two
             mov b,d                ; characters
             call put_byte          ; of fill type. (i.e. 'RAM*RAM')
             mov b,e                ; Mov ctr back
             inr h                  ; Inc the page ctr
             mov a,h                ; Is 
             ora a                  ; it 0?
             jz w_t_all             ; If so, we're done
             jmp put_byte           ; Else store a third character of fill typ

w_show_a:    push h                 ; Save mem counter
             shld tmp_2             ; Store it for showing
             call crlf              ; Show a CRLF
             lxi h,tmp_2            ; Point to saved ctr
             call showword          ; Show it
             pop h                  ; Get saved value
             mvi b,':'              ; Show a
             call put_byte          ; colon.
             mvi b,' '              ; Show a 
             jmp put_byte           ; space & return.

w_s_end:     jmp w_loop             ; Keep doing the summary

w_t_all:     pop h                  ; Don't smash the stack!
             call crlf              ; Show 2
             call crlf              ; CRLF's
             jmp loop               ; Quit

int_table:   .dw ms_fill,ms_mt,ms_ram,ms_rom ; Table to point to fill types

ms_ram:      .db "RAM*\0"           ; The 
ms_rom:      .db "EPROM*\0"         ;  various
ms_mt:       .db "VACANT*\0"        ;  fill
ms_fill:     .db "FILL*\0"          ; types.

; Starts a user's program at the indicated
; address.

go:          xchg                   ; \
             call get_hex           ;  Get the start address 
             xchg                   ; /
             jmp goto_usr           ; Start the user's program            

; Goes from the start address
; until a 'RET' is encountered

retgo:       xchg                   ; \
             call get_hex           ;  Get the start address
             lhld reg_sp            ; Put
             sphl                   ;  the 
             dcx h                  ;   return
             dcx h                  ;    address in the
             shld reg_sp            ;     user stack area
             lxi h,rtrnhere         ;    and restore
             push h                 ;   the
             lxi sp,stack           ;  monitor's
             xchg                   ; stack.
                                    ; Fall thru to start user's program

; Launches user's program at HL using stored regs & flags             

goto_usr:    shld reg_pc            ; Save the start address
             lhld reg_bc            ; Get the BC pair
             push h                 ; Transfer it
             pop b                  ; to BC.
             lhld reg_de            ; Get the DE pair
             xchg                   ; Transfer it to DE
             lhld reg_psw           ; Get the PSW
             push h                 ; Transfer it
             pop psw                ; to the PSW
             lhld reg_sp            ; Get the user's SP
             sphl                   ; Set SP to user area
             lhld reg_pc            ; Get the start address
             push h                 ; Save it 
             lhld reg_hl            ; Get the HL reg
             ret                    ; JMP to user's start address

;When we get back from the user's program, go here

rtrnhere:    push psw               ; Save the PSW
             shld reg_hl            ; Save the H/L reg
             xchg                   ; Mov DE->HL
             shld reg_de            ; Save it
             push b                 ; Mov BC->
             pop h                  ;  HL.
             shld reg_bc            ; Save it
             pop h                  ; Get saved PSW
             shld reg_psw           ; Store it
             lxi h,0                ; Get the
             dad sp                 ;  stack pointer
             shld reg_sp            ; and store it.
             lxi sp,stack           ; Restore monitor's stack
             lxi h,ms_wertn         ; Show the 'At least we returned
             call dcomp             ; message.
             call sho_rgs           ; Show the regs
             jmp loop               ; Quit

;Shows the registers and a disasm @ PC

sho_rgs:     lxi h,ms_rgs           ; Show the reg line ('AC -BC- -DE-...')
             call dcomp             ; Do it
             lxi h,reg_psw+1        ; Point to the ACC
             call showbyte          ; Show it
             mvi b,' '              ; Show a space
             call put_byte          ; Do it
             mvi d,4                ; Loop of 4

s_r_loop:    call showword          ; Show the register
             mvi b,' '              ; Show a
             call put_byte          ; space.
             inx h                  ; Inc word pointer
             dcr d                  ; Dec CTR
             jnz s_r_loop           ; Done? No, keep doing it
             lda reg_psw            ; Get the flags
             mvi d,8                ; # of bits
             mov e,a                ; Save it in E
             
s_rloop:     mov a,e                ; Rotate
             ral                    ;  the E
             mov e,a                ; reg.
             mvi a,h'30             ; Mov ASCII '0' to the ACC
             aci 0                  ; Add the carry flag to make a '1' if CY
             mov b,a                ; Mov it to B
             call put_byte          ; Show it
             dcr d                  ; DEC ctr
             jnz s_rloop            ; Done? if not, keep doing it
             mvi b,' '              ; Show a 
             call put_byte          ; space.
             lhld reg_pc            ; Get the PC
             call disasm1           ; Show a 1-line disasm
             ret                    ; Quit

; Single Steps the user's program

ss:          mvi b,h'0c             ; Clear the
             call put_byte          ; screen.
             lxi h,ms_sshlp         ; Show the
             call dcomp             ; 'need help' message.
             
ss_loop:     lxi h,ms_ss_pt         ; Show a 'SS>'
             call dcomp             ;  as a prompt.
             call get_usr           ; Get user's input
             
; I yanked this from the beginning- no sense
; re-inventing the wheel! ;-)
             
             xra a                  ; Is the # of bytes in the buffer
             cmp b                  ; =0? ;i.e. the user just pressed
             jz do_step             ; enter.  If so, do one step
             lda buffer             ; Get 1st char of buffer
             lxi h,ss_itabl         ; Point to instructions
             mvi c,h'fe             ; Set pointer to -2

ss_wloop:    inr c                  ; Inc pointer
             inr c                  ; twice.
             cmp m                  ; Compare it to the buffer
             jz ss_hit              ; If the same, do more comparing
             inx h                  ; Inc table addr
             inx h                  ; twice.
             mov b,a                ; Save the compared-to character
             mov a,c                ; Are we at the end
             cpi 5*2                ; of the table?
             mov a,b                ; Un-save the reg
             jnz ss_wloop           ; If not, try again
             
ss_ugoh:     lxi h,ms_you           ; Otherwise, show user
             call dcomp             ; that he entered something wrong
             jmp ss_loop            ; and get another entry.

ss_hit:      lda buffer+1           ; We got the 1st char, try for # 2
             inx h                  ; Inc table pointer
             cmp m                  ; If that's it, we're done
             jz s_found             ; Goto found, if we found it
             lda buffer             ; We didn't find it. Restore the
             inx h                  ; original buffer char, but point to
             jmp ss_wloop           ; the next entry and try again.

s_found:     mvi b,0                ; Set b=0 so we can adjust the addr tabl
             lxi h,swhere           ; Point to table
             dad b                  ; Adjust pointer
             mov d,m                ; Get high-order byte
             inx h                  ; Inc pointer
             mov e,m                ; Get low-order byte
             lxi h,buffer           ; Point to buffer again
             mvi c,21               ; # of bytes in buffer
             mvi a,h'20             ; Set to space char. ' '

swh_loop:    cmp m                  ; Is the buffer at a space?
             jz send_ins            ; If so, we're at the end of the ins.
             inx h                  ; Inc pointer
             dcr c                  ; Dec counter
             jz ss_ugoh             ; If the ctr is 0, the user screwed up
             jmp swh_loop           ; Otherwise, keep doing it                                   

send_ins:    inx h                  ; Inc the buffer pointer
             xchg                   ; Mov DE-HL
             pchl                   ; Point the PC to the app. subroutine
             
swhere:      .dw regs2,mode2,back,step,help  ; sub table           

ss_itabl:    .db "RGMOBASTHE"       ; valid ins. table
             
help:        lxi h,ms_ssmnu         ; Show the
             call dcomp             ; SS help
             jmp ss_loop            ; menu

mode2:       xchg                   ; Get the 
             call get_hex2          ;  mode
             xchg                   ; number.
             lda tmp_4              ; Did the user
             ora a                  ; screw up?
             jz ss_loop             ; Is so, get another entry
             mov a,h                ; Is the upper byte
             ora a                  ; not 0?
             jnz inv_mode           ; If so, error out
             mov a,l                ; Is the lower
             ani h'fe               ; byte not 0 or 2?
             jnz inv_mode           ; If so, error out
             mov a,l                ; Mov mode # to A
             sta ss_mode            ; Store it
             jmp ss_loop            ; Quit

inv_mode:    lxi h,ms_illmd         ; Tell user
             call dcomp             ;  he entered an invalid mode
             jmp ss_loop            ; and quit.

step:        xchg                   ; Get the 
             call get_hex2          ;  number
             xchg                   ; of steps to do.
             lda tmp_4              ; Invalid
             ora a                  ; entry?
             jz ss_loop             ; If so, get another

step_lp:     mov a,h                ; Is the # of steps
             ora l                  ; = to 0?
             jz do_step2            ; If so, we're done
             dcx h                  ; Dec # of steps
             push h                 ; Save our counter
             call rdo_step          ; Do one step
             pop h                  ; Get saved counter
             jmp step_lp            ; Keep doing it

do_step:     call rdo_step          ; Do one step

do_step2:    lda ss_mode            ; Is the
             ora a                  ; mode=0?
             cz clr_term            ; If so, clear the term.
             call sho_rgs           ; Show the regs
             jmp ss_loop            ; Go back
                                    
;  tmp_1 holds original addr
;  tmp_2 holds addr of next op-code
;  tmp_4 has prev. modded stack

;  buffer:
;  
;  0 - opcode
;  1 - db1
;  2 - db2
;  3 - rst 7
;  4 - not used
;  5 - rst 7
;  6,7 - not used
;  8 - flag: 00-no mod stack, ff-mod stack
; The below code will perform a single step taking into
; account conditional calls, returns, jumps, etc.
; HLT will cause the stepped program to get stuck at that
; op-code, rather than crashing the monitor.
; RST N op-codes will affect the single-step just like they
; were actually executed; i.e. doing a RST 1 will push the
; return address and jump to 0008 and continue execution there.
; All instructions except interrupts are supported.

rdo_step:    lhld reg_pc            ; Get the PC
             shld tmp_1             ; Store it for later use
             lxi d,buffer           ; Point to a garbage spot to store
             push h                 ; mnemonics generated (not used).
             push d                 ; Save both RP's
             call docode            ; Get the # of bytes the op-code takes
             xra a                  ; Clear the
             sta buffer+8           ; op-type register.
             mov c,b                ; Adjust the
             mvi b,0                ; current PC
             dad b                  ;  to point to
             shld tmp_2             ; the next op-code.
             pop d                  ; Get saved
             pop h                  ; RP's.
             mov a,m                ; Get op-code
             stax d                 ; Store it in the buffer
             dcr c                  ; Dec op-code byte register
             jz ss_2byte            ; If it was a 1, we have a 2-byte op-code
             dcr c                  ; Try for a 2
             jnz ss_1byte           ; If it wasn't, we have a one-byte op

ss_3byte:    cpi h'cd               ; Otherwise, it's a 3-byte op.
             jz ss_call             ; Is it a plain CALL?
             cpi h'c3               ; Is it a
             jz ss_jmp              ; plain JMP?
             ani h'c7               ; Strip un-necessary bits
             cpi h'c4               ; Is it a cond. 
             jz ss_ccall            ; CALL?
             cpi h'c2               ; Is it a cond.
             jz ss_jmp              ; JMP?
             inx h                  ; Nope, not any of the above.
             inx d                  ; Move the 1st
             mov a,m                ;  databyte
             stax d                 ; to the buffer (after op-code).

ss_2byte:    inx h                  ; Store the 1st (or 2nd) databyte
             inx d                  ;  after the
             mov a,m                ;  op-code
             stax d                 ; in the buffer.
             jmp ss_cheat           ; We're ready to simulate.

ss_call:     mvi a,h'c3             ; Store a JMP to 
             sta buffer             ; replace the CALL.
             mvi a,1                ; 1 for CALL
             jmp ss_j_2             ; We're ready to simulate.

ss_ccall:    lda buffer             ; Change a cond. CALL
             xri h'06               ;  to a
             sta buffer             ; cond. JMP.
             mvi a,2                ; 2 for cond. CALL
             jmp ss_j_2             ; We're ready to simulate.

ss_ret:      mvi a,h'c3             ; Change RET to
             sta buffer             ; JMP.
             mvi a,4                ; 4 for RET
             jmp ss_j_2             ; We're ready to simulate.

ss_cret:     lda buffer             ; Change cond. RET
             xri h'02               ;  to cond.
             sta buffer             ; JMP.
             mvi a,5                ; 5 for cond. ret
             jmp ss_j_2             ; We're ready to simulate.

ss_jmp:      mvi a,h'3              ; A value of 3 for a JMP

ss_j_2:      sta buffer+8           ; Save the op-type
             lxi d,buffer+1         ; Store the
             mvi a,(ss_rtn) & h'ff  ;  vector
             stax d                 ;   address of
             inx d                  ;   'ss_rtn'
             mvi a,(ss_rtn) >> 8    ;  after the
             stax d                 ; JMP.
             
ss_cheat:    mvi a,h'c3             ; Store a JMP op-code
             inx d                  ; Store the
             stax d                 ;  vector
             mvi a,ss_rtn2 & h'ff   ;   address 
             inx d                  ;    of
             stax d                 ;    'ss_rtn'
             mvi a,ss_rtn2 >> 8     ;   after
             inx d                  ;  the
             stax d                 ; JMP.
             jmp ss_next            ; Do the simulation
           
ss_1byte:    cpi h'c9               ; Is it 
             jz ss_ret              ; a RET instruction?
             cpi h'e9               ; Is it
             jz ss_pchl             ; a PCHL instruction?
             cpi h'76               ; Is it a HLT instruction?
             rz                     ; If so, quit.
             ani h'c7               ; Strip bits
             cpi h'c0               ; Is it a 
             jz ss_cret             ; cond. RET?
             cpi h'c7               ; Is it a
             jz ss_rst              ; RST n?
             jmp ss_cheat           ; Do the simulation

ss_rst:      lhld tmp_2             ; Load the return addr.
             xchg                   ; 'Push'
             lhld reg_sp            ;  the return
             dcx h                  ;   addr.
             mov m,d                ;    onto
             dcx h                  ;   the
             mov m,e                ;  user
             shld reg_sp            ; stack.
             lhld tmp_1             ; Get start addr.
             mov a,m                ; Get op-code
             xri h'c7               ; Adjust to get low address
             mov l,a                ; Mov it over
             mvi h,0                ; Set hi to 0
             shld reg_pc            ; Store new PC
             ret                    ; Quit
                                    
ss_pchl:     lhld reg_hl            ; Mov the HL
             shld reg_pc            ; to the PC.
             ret                    ; Quit

ss_next:     lxi h,0                ; Save the
             dad sp                 ;  original
             shld tmp_3             ; SP.
             lhld reg_bc            ; Get the BC pair
             push h                 ; Transfer it
             pop b                  ; to BC.
             lhld reg_de            ; Get the DE pair
             xchg                   ; Transfer it to DE
             lhld reg_psw           ; Get the PSW
             push h                 ; Transfer it
             pop psw                ; to the PSW
             lhld reg_sp            ; Get the user's SP
             sphl                   ; Set SP to user area
             lhld reg_hl            ; Get the HL reg
             jmp buffer             ; Goto the simulated instruction

;   ----------- buffer jumps back here -----------

ss_rtn2:     push psw               ; Save the PSW
             xra a                  ; Set to 1
             inr a                  ; for no_cond mode.
             jmp ss_rtn3            ; Save rest of regs

ss_rtn:      push psw               ; Save the PSW
             xra a                  ; Set to 0 for cond. mode
             
ss_rtn3:     shld reg_hl            ; Save the H/L reg
             xchg                   ; Mov DE->HL
             shld reg_de            ; Save it
             push b                 ; Mov BC->
             pop h                  ;  HL.
             shld reg_bc            ; Save it
             pop h                  ; Get saved PSW
             shld reg_psw           ; Store it
             lxi h,0                ; Get the
             dad sp                 ;  stack pointer
             shld reg_sp            ; and store it.
             lhld tmp_3             ; Restore
             sphl                   ; original SP.
             mov c,a                ; Mov cond. status to C
             lda buffer+8           ; Get op-type
             ora a                  ; Is it 0?
             jz sr_noti             ; If so, no playing is needed
             dcr a                  ; Was it a
             jz sr_call             ; CALL?
             dcr a                  ; Was it a
             jz sr_ccall            ; Cond. CALL?
             dcr a                  ; Was it a
             jz sr_jmp              ; JMP?
             dcr a                  ; Was it a
             jz sr_ret              ; RET?
             
sr_cret:     mov a,c                ; It's a cond. RET
             ora a                  ; Did the condition
             jz sr_ret              ; occur?  If so, take care of it.
             lhld tmp_2             ; Otherwise, skip it
             shld reg_pc            ; and goto next instruction.
             ret                    ; Quit

sr_ret:      lhld reg_sp            ; Do 
             mov e,m                ;  a
             inx h                  ;   manual
             mov d,m                ;    'RET'
             inx h                  ;    from
             shld reg_sp            ;   the
             xchg                   ;  stack 
             shld reg_pc            ; to PC.
             ret                    ; Quit

sr_noti:     lhld tmp_2             ; Nothing doing.
             shld reg_pc            ; Point to next op-code &
             ret                    ; Quit

sr_call:     lhld tmp_2             ; Do
             xchg                   ;  a
             lhld reg_sp            ;   manual
             dcx h                  ;    PC
             mov m,d                ;    'push'
             dcx h                  ;   onto
             mov m,e                ;  the
             shld reg_sp            ; user stack.
             lhld tmp_1             ; Get
             inx h                  ;  the
             mov e,m                ;   location
             inx h                  ;    pointed
             mov d,m                ;    to in the
             xchg                   ;   CALL and
             shld reg_pc            ;  point PC to it.
             ret                    ; Quit

sr_ccall:    mov a,c                ; Did the
             ora a                  ; conditional, erm, condition?
             jz sr_call             ; If so, do a call
             lhld tmp_2             ; Otherwise, point to
             shld reg_pc            ; next op-code &
             ret                    ; Quit

sr_jmp:      lhld tmp_1             ; Was that 
             mvi a,h'c3             ;  a plain-old
             cmp m                  ; JMP?
             jz srj_1               ; If so, go here
             mov a,c                ; Did the
             ora a                  ; conditional, condition?
             jz srj_1               ; If so, go here
             lhld tmp_2             ; Nope. Point the
             shld reg_pc            ; PC to the next op-code.
             ret                    ; Quit

srj_1:       inx h                  ; Get the
             mov e,m                ;  JMP'ed
             inx h                  ;   to address
             mov d,m                ;    and put
             xchg                   ;   it in the
             shld reg_pc            ;  PC.
             ret                    ; Quit

clr_term:    mvi b,h'0c             ; Clear the
             jmp put_byte           ; term and return.

back:        lxi h,ms_thank         ; Thank user and go back
             call dcomp             ; to main
             jmp loop               ; loop.


regs2:       call reg2              ; Call regs from 
             jmp ss_loop            ; SS mode.

register:    call reg2              ; Call regs from
             jmp loop               ; normal mode.

reg2:        mvi a,'F'              ; Is user setting a flag?
             xchg                   ; Switch around to check
             cmp m                  ; Do the comp.
             jz re_flags            ; If so, do the flag
             mvi a,' '              ; Set-up for 1/2 chr check
             mov b,m                ; Save 1st chr
             inx h                  ; Inc pointer
             shld tmp_2             ; Store it
             cmp m                  ; Is the next chr ' '? (i.e. 1 chr)
             jz re_one              ; If so, it's a single reg
             lxi h,re_val2          ; See which RP
             call re_try            ; was used.
             ora a                  ; No match?
             jz re_quit             ; If so, tell user off & quit
             mov a,c                ; Mov for *2
             lxi h,reg_bc           ; Point to 1st RP
             rlc                    ; Mul by 2 to adj for RP's
             ani h'0e               ; Strip off junk
             mov e,a                ; Mov it bacck
             mvi d,0                ; Set hi to 0
             dad d                  ; Adj the pointer
             shld tmp_3             ; Save pointer
             lhld tmp_2             ; Get previously saved pointer
             inx h                  ; Inc pointer
             inx h                  ; twice.
             call get_hex2          ; Get the actual value
             lda tmp_4              ; Did the user
             ora a                  ; screw up?
             rz                     ; Is so, quit
             lhld tmp_3             ; Get saved addr
             mov m,e                ; Store lo byte of RP
             inx h                  ; Inc pointer
             mov m,d                ; Store hi byte of RP
             jmp sho_rgs            ; Show the regs & quit

re_flags:    inx h                  ; Inc pointer
             shld tmp_2             ; Store it
             mov b,m                ; See which
             lxi h,re_val3          ;  flag was
             call re_try            ; used.
             ora a                  ; If Acc=0, invalid
             jz re_quit             ; Tell user off if wrong
             inr c                  ; Inc counter
             mvi d,h'80             ; Set D for rotating

re_fllp:     mov a,d                ; Rotate D
             rlc                    ;  correct
             mov d,a                ;   # of times
             dcr c                  ;  to get right
             jnz re_fllp            ; flag.
             mov a,d                ; Mov adj. bit mask
             sta tmp_3              ; Store it
             lhld tmp_2             ; Get saved addr
             inx h                  ; Inc it
             mvi a,'0'              ; Try against '0' (bit polarity)      
             cmp m                  ; Do the compare
             jz re_fl0              ; If it matches, user wants flag off
             lda tmp_3              ; Get mask
             mov b,a                ; Mov it ovver
             lda reg_psw            ; Load flags
             ora b                  ; Set one flag
             sta reg_psw            ; Store flags
             jmp sho_rgs            ; Show the regs & quit

re_fl0:      lda tmp_3              ; Get the bit mask
             cma                    ; Comp it
             mov b,a                ; Mov it
             lda reg_psw            ; Get flags
             ana b                  ; Turn off 1 flag
             sta reg_psw            ; Store flags
             jmp sho_rgs            ; Show regs & quit
                                    
re_one:      cmp b                  ; Did user want just a reg show?
             jz sho_rgs             ; If so, show it & quit
             inx h                  ; Inc pointer
             shld tmp_2             ; Store it
             lxi h,re_val1          ; Try to find a 
             call re_try            ; match to user's entry.
             ora a                  ; Did the user screw up?
             jz re_quit             ; If so, tell him off & quit
             mvi b,0                ; Set b to 0
             lxi h,reg_psw+1        ; Point to Acc->H regs
             dad b                  ; Adj to right reg
             shld tmp_3             ; Store it
             lhld tmp_2             ; Get saved addr
             call get_hex2          ; Get the hex val
             lda tmp_4              ; Did the user
             ora a                  ; screw up?
             rz                     ; Is so, quit
             xra a                  ; Is the ans. bigger than
             cmp d                  ; H'ff? 
             jnz re_quit            ; If so, tell user off & quit
             lhld tmp_3             ; Get saved pointer
             mov m,e                ; Store the val in the reg
             jmp sho_rgs            ; Show regs & quit

re_quit:     lxi h,ms_inv           ; Show the invalid ins. message
             jmp dcomp              ; Show it

re_try:      mvi c,0                ; Set ctr to 0

re_trlp:     mov a,m                ; Get a char to test
             ora a                  ; Is it null?
             rz                     ; If so, quit; unsucessful
             cmp b                  ; Check against user's entry
             rz                     ; If they match, quit
             inr c                  ; Otherwise, inc ctr
             inx h                  ; and pointer.
             jmp re_trlp            ; Try again

re_val1:     .db "ACBEDLH\0"        ; One-letter ops
re_val2:     .db "BDHSP\0"          ; Two-letter ops
re_val3:     .db "C3P2A1ZS\0"       ; Flag ops
                  
comp:        xchg                   ; Mov DE -> HL
             call get_hex           ; Get the start addr.
             xchg                   ; Mov it to H/L
             xra a                  ; If the number is over
             cmp h                  ; h'ff, then
             jnz too_big2           ; Show the user & quit.
             mvi h,h'c9             ; Load high with opcode 'RET'
             mov d,l                ; Save the port addr
             mov a,d                ; And to
             sta tmp_1              ; memory.
             push h                 ; Push the 1st part
             lxi h,h'd32f           ; Load HL with ops 'OUT & CMA'
             push h                 ; Store them
             mov h,d                ; Get saved value
             mvi l,h'db             ; Set l with op 'IN'
             push h                 ; Store them
             lxi h,0                ; Get the
             dad sp                 ; stack pointer.
             xchg                   ; Save it temp.
             lxi h,comp_ret         ; Store the
             push h                 ; return addr.
             xchg                   ; Get saved addr.
             pchl                   ; Call the routine we just made
             
comp_ret:    pop h                  ; Point SP
             pop h                  ;  back where
             pop h                  ; it belongs.
             cma                    ; CMP the acc
             sta tmp_1+1            ; Store it for showing
             lxi h,cmp_dat          ; Show the 'CMP port#' mess.
             call string            ; Do it
             lxi h,tmp_1            ; Point to the port#
             call showbyte          ; Show it
             lxi h,get_dat2         ; Show the '-->' message
             call string            ; Do it
             lxi h,tmp_1+1          ; Show the
             push h                 ;  value
             call showbyte          ; and save the addr.
             lxi h,cmp_dat3         ; Show the 'to' mess.
             call string            ; Show it
             pop h                  ; Get saved addr.
             mov a,m                ; CMP the
             cma                    ;  value 
             mov m,a                ; to show change.
             call showbyte          ; Show it
             call crlf              ; Do a CRLF
             jmp loop               ; Quit

cmp_dat:     .db "COMP'D PORT#\0"   ; cmp'd port message
cmp_dat2:    .db "-->\0"            ; Arrow for CP mess.
cmp_dat3:    .db " TO \0"           ; TO message fo CP

games:       mvi a,'0'              ; Game 0
             xchg                   ; Mov it
             cmp m                  ; Compare
             jz game1               ; If 0, game 1
             inr a                  ; Inc to 1
             cmp m                  ; Compare
         ;    jz game2               ; If 1, game 2
             jmp loop               ; Quit
            
game1:       call h'2000            ; Call the 1st game
             jmp loop               ; Quit

game2:       jmp loop               ; Quit

; end of ROM data

; Memory variables:

 .org mem_strt

buffer:      .rs 21                 ; Set-up a buffer for user's input
buffer2:     .rs 10                 ; Set-up a buffer for mnemonic storage
tmp_1:       .rs 2                  ; Tmp word storage #1
tmp_2:       .rs 2                  ; Tmp word storage #2
tmp_3:       .rs 2                  ; Tmp word storage #3
tmp_4:       .rs 2                  ; Tmp word storage #4
ss_mode:     .rs 1                  ; Store the SS mode
reg_psw:     .rs 2                  ; PSW word storage
reg_bc:      .rs 2                  ; BC reg storage
reg_de:      .rs 2                  ; DE reg storage
reg_hl:      .rs 2                  ; HL reg storage
reg_sp:      .rs 2                  ; SP word storage
reg_pc:      .rs 2                  ; PC word storage
nextpc:      .rs 2                  ; Next PC addr storage

 .end                               ; *YES* the END!!!






