 .org h'205b

 

; My version of the 'minesweeper' game.  Plays just like the original.


mined:       lxi h,warning
             call string
             call get_byte
             mvi a,'y'
             cmp b
             jz play_it
             mvi a,'Y'
             cmp b
             jz play_it
             ret

warning:     .db "Warning: CoreSweeper will trash your RAM contents. \n\r"
             .db "Continue? (Y/N) \0"

play_it:     lxi h,ms_init
             call string
             call get_byte
             mov a,b
             cpi 'Y'
             cz sho_ins
             cpi 'y'
             cz sho_ins
             
start:       lxi h,ms_sizex
             call string
             lxi h,h'1061
             call get_num
             sta x_size
             lxi h,ms_sizey
             call string
             lxi h,h'1021
             call get_num
             sta y_size
             lxi h,ms_diff
             call string
             lxi h,h'0106
             call get_num
             sta diff
             lxi h,ms_wait
             call string
             lda diff
             mov c,a
             lda x_size
             mov b,a
             lda y_size
             add b
             rrc
             ani h'7f
             mov b,a

gml_loop:    dcr c
             jz gml_cont
             add b
             jmp gml_loop

gml_cont:    sta mines
             lda x_size
             mov h,a
             lda y_size
             dcr a
             mov l,a

gg_loop:     dcr h
             xra a  
             call stoarray
             mov a,h
             ora a
             jnz gg_loop
             lda x_size
             mov h,a
             dcr l
             mov a,l
             inr a
             jnz gg_loop
             lda mines
             sta mctr
             lhld alpha
             mov a,h
             ora l
             jnz gh_loop
             lxi h,h'1289
             shld alpha

gh_loop:     call random
             call random
             call random
             call random
             call random
             call random
             ani h'3f
             mov d,a
             lda x_size
             dcr a
             cmp d
             jc gh_loop

gi_loop:     call random
             call random
             call random
             call random
             call random
             ani h'1f
             mov e,a
             cpi 0
             jz illegal
             cpi 1
             jz illegal
             
ill_ret:     lda y_size
             dcr a
             cmp e
             jc gi_loop
             xchg
             call getarray
             ora a  
             jnz gh_loop
             mvi a,'*'
             call stoarray
             lda mctr
             dcr a
             sta mctr
             cpe update
             jnz gh_loop
             
; end of randomizing loop             

             lxi h,0

gk_loop:     mvi c,0
             push h
             call getarray
             cpi '*'
             jz no_gklp
             pop h
             push h
             inr h
             lda x_size
             cmp h
             jz next_1
             call getarray
             cpi '*'
             jnz next_1
             inr c

next_1:      pop h
             push h
             dcr h
             xra a
             cma
             cmp h
             jz next_2
             call getarray
             cpi '*'
             jnz next_2
             inr c


next_2:      pop h
             push h
             inr l
             lda y_size
             cmp l
             jz next_3
             call getarray
             cpi '*'
             jnz next_3
             inr c

next_3:      pop h
             push h
             dcr l
             xra a
             cma
             cmp l
             jz next_4
             call getarray
             cpi '*'
             jnz next_4
             inr c

next_4:      pop h
             push h
             dcr h
             dcr l
             xra a
             cma
             cmp h
             jz next_5
             cmp l
             jz next_5
             call getarray
             cpi '*'
             jnz next_5
             inr c


next_5:      pop h
             push h
             inr h
             dcr l
             xra a
             cma
             cmp l
             jz next_6
             lda x_size
             cmp h
             jz next_6
             call getarray
             cpi '*'
             jnz next_6
             inr c

next_6:      pop h
             push h
             dcr h
             inr l
             xra a
             cma
             cmp h
             jz next_7
             lda y_size
             cmp l
             jz next_7
             call getarray
             cpi '*'
             jnz next_7
             inr c


next_7:      pop h
             push h
             inr h
             inr l
             lda x_size
             cmp h
             jz next_8
             lda y_size
             cmp l
             jz next_8
             call getarray
             cpi '*'
             jnz next_8
             inr c

next_8:      mov a,c
             ora a
             jz no_gklp
             adi h'30
             pop h
             push h
             call stoarray

no_gklp:     pop h
             inr h
             lda x_size
             cmp h
             jnz gk_loop
             mvi h,0
             call turn_it
             inr l
             lda y_size
             cmp l
             jnz gk_loop
             
; ------- end of number marker thingy -------             
             
             lxi h,0
             shld moves
             shld y_plyr
             mov a,l
             sta marks
             jmp redraw

mainloop:    call get_byte
             mov a,b
             cpi h'1b
             jz contcode
             
secloop:     cpi 'd'
             jz redraw
             cpi 'D'
             jz redraw
             cpi 'h'
             jz exit
             cpi 'H'
             jz exit
             cpi 'g'
             jz sweep
             cpi 'G'
             jz sweep
             cpi 'r'
             jz newgame
             cpi 'R'
             jz newgame
             cpi 'm'
             jz markit
             cpi 'M'
             jz markit
             cpi 's'
             jz superusr
             cpi 'S'
             jz superusr
             jmp mainloop

contcode:    call get_byte
             mov a,b
             cpi '['
             jnz secloop
             call get_byte
             mov a,b
             cpi 'A'
             jz mov_up
             cpi 'B'
             jz mov_dn
             cpi 'C'
             jz mov_rt
             cpi 'D'
             jz mov_lf
             jmp mainloop

mov_dn:      lda y_plyr
             inr a
             sta y_plyr
             mov b,a
             lda y_size
             cmp b
             jnz update_it
             dcr a
             sta y_plyr
             jmp mainloop

mov_up:      lda y_plyr
             dcr a
             sta y_plyr
             cpi h'ff
             jnz update_it
             inr a
             sta y_plyr
             jmp mainloop

mov_lf:      lda x_plyr
             dcr a
             sta x_plyr
             cpi h'ff
             jnz update_it
             inr a
             sta x_plyr
             jmp mainloop

mov_rt:      lda x_plyr
             inr a
             sta x_plyr
             mov b,a
             lda x_size
             cmp b
             jnz update_it
             dcr a
             sta x_plyr
             jmp mainloop

update_it:   call position
             jmp mainloop

position:    call control
             lda y_plyr             
             inr a
             inr a
             call do_math
             mvi b,';'
             call put_byte
             lda x_plyr
             inr a
             inr a
             mov b,a
             lda centre
             add b
             call do_math
             mvi b,'H'
             jmp put_byte

superusr:    mvi a,7
             call setcolor
             call cls
             
sup_newl:    call crlf
             mvi b,'>'
             call put_byte

sup_loop:    call get_byte
             mov a,b
             cpi 10
             jz sup_newl
             cpi 13
             jz sup_newl
             cpi h'1b
             jz redraw
             call put_byte
             jmp sup_loop

redraw:      call showgrid
             jmp mar_pass

newgame:     jmp start

sweep:       lda x_plyr
             mov h,a
             lda y_plyr
             mov l,a
             call getarray
             cpi 0
             jz do_sweep
             cpi '*'
             jz boom
             mov b,a
             ani h'b0
             cpi h'30
             jnz mainloop
             mov a,b
             ori h'80
             call stoarray
             call show_1
             jmp mainloop

boom:        mvi b,h'30
             
boomloop:    push b
             call control
             mvi b,'4'
             call put_byte
             pop b
             push b
             mov a,b
             dcr a
             ani h'7
             adi h'30
             mov b,a
             call put_byte
             mvi b,'m'
             call put_byte
             call cls
             pop b
             dcr b
             jnz boomloop
             lxi h,ms_plyrs
             call string
             call get_byte
             lxi h,0
             mov a,b
             cpi 'Y'
             jz boo_loop
             cpi 'y'
             jz boo_loop
             jmp skip_bol

boo_loop:    call getarray
             cpi '*'|h'40
             push psw
             cz change_bo
             pop psw
             push psw
             cpi '*'
             cz change_bm
             pop psw
             mov b,a
             ani h'40
             cnz try_mark
             inr h
             lda x_size
             cmp h
             jnz boo_loop
             xra a
             mov h,a
             inr l
             lda y_size
             cmp l
             jnz boo_loop
             lhld y_plyr
             mvi a,'X'
             call stoarray
             call showgrid
             
skip_bol:    lxi h,ms_again            
             call string
             call get_byte
             mov a,b
             cpi 'Y'
             jz start
             cpi 'y'
             jz start
             jmp exit


try_mark:    mov a,b
             cpi '*'|h'40
             rz
             mvi a,':'             
             jmp stoarray

change_bm:   mvi a,''
             jmp stoarray

change_bo:   mvi a,''
             jmp stoarray

donewith:    lda marks
             mov b,a
             lda mines
             cmp b
             rnz
             lxi h,0
             mov d,l

don_loop:    push d
             call getarray
             pop d
             cpi '*'|h'40
             cz inc_ctr
             inr h
             lda x_size
             cmp h
             jnz don_loop
             xra a
             mov h,a
             inr l
             lda y_size
             cmp l
             jnz don_loop
             lda mines
             cmp d
             rnz
             pop h
             lxi h,ms_win
             call string
             lda mines
             mov e,a
             mvi d,0
             lhld moves
             xchg
             push h
             pop b
             dad h         
             dad b         
             dad b         
             dad b  
             dad h  
             push h
             pop b           
             dad h           
             dad b           
             dad b           
             dad b           
             dad h           
             xra a         
             mov b,a
             mov c,a
             ora d
             ora e
             ora h
             ora l
             jz div_by_0
             mov a,h
             cma
             mov h,a
             mov a,l
             cma
             mov l,a
             inx h

div_loop:    dad d
             inx b
             jnc div_loop
             
div_by_0:    mov a,c
             call do_math2
             mvi a,h'b
             call setcolor
             mvi b,'%'
             call put_byte
             lxi h,ms_again
             call string
             call get_byte
             mov a,b
             cpi 'Y'
             jz start
             cpi 'y'
             jz start
             
exit:        lxi h,ms_thank
             call string
             call random
             ani h'f
             adi 'A'
             mov b,a
             call put_byte
             lxi h,ms_than1
             call string
             call random
             mov a,l
             ani h'f
             call do_math
             lxi h,ms_than2
             call string
             ret
             

inc_ctr:     inr d
             ret

do_sweep:    lda y_size
             adi 3
             mov l,a
             mvi h,0
             call coord
             lhld y_plyr
             call recurse
             call position
             jmp mainloop

recurse:     xra a
             cma
             cmp l
             rz
             cmp h
             rz
             lda x_size
             cmp h
             rz
             lda y_size
             cmp l
             rz
             call getarray
             ora a
             jz part2
             cpi ' '
             rz
             ori h'80
             jmp shoarray

part2:       mvi a,' '
             call shoarray
             inr h
             call recurse
             dcr h
             dcr l
             call recurse
             inr l
             inr l
             call recurse
             dcr l
             dcr h
             call recurse
             inr h
             ret

turn_it:     push h
             push psw
             lda tmp
             inr a
             sta tmp
             ani h'3
             lxi h,turn_dat
             mov c,a
             mvi b,0
             dad b
             mov b,m
             call put_byte
             call control
             mvi b,'1'
             call put_byte
             mvi b,'D'
             call put_byte
             pop psw
             pop h
             ret

turn_dat:    .db "/-\\|"

fix_coord:   lda centre
             adi 2
             add h
             mov h,a
             inr l
             inr l

coord:       call control
             mov a,l
             call do_math
             mvi b,';'
             call put_byte
             mov a,h
             call do_math
             mvi b,'H'
             jmp put_byte

markit:      lhld moves
             inx h
             shld moves
             mov a,h
             ora l
             jnz do_roll
             dcx h

do_roll:     lhld y_plyr
             call getarray
             mov b,a
             ani h'40
             jnz mark_on
             lda marks
             mov c,a
             lda mines
             dcr a
             cmp c
             jc mainloop
             inr c
             mov a,c
             sta marks
             mov a,b
             xri h'40
             call stoarray
             push h
             call show_1
             pop h
             call donewith
             jmp mar_pass

mark_on:     lda marks
             ora a
             jz mainloop
             dcr a
             sta marks
             mov a,b
             xri h'40
             call stoarray
             mov b,a
             ani h'80
             jz show_blnk
             push h
             call show_1
             pop h

mar_pass:    mvi a,h'b
             call setcolor
             lda centre
             mov b,a
             lda x_size
             add b
             adi 12
             mov h,a
             mvi l,5
             call coord
             lda mines
             call do_math2
             inr l
             inr l
             call coord
             lda marks
             call do_math2
             inr l
             inr l
             call coord
             lhld moves
             call do_math3
             call position
             jmp mainloop

show_blnk:   mov a,b
             cpi ' '
             jz show_sp
             push h
             mvi a,h'6
             call setcolor
             pop h
             call tile
             jmp mar_pass

tile:        mov a,l
             add h
             rrc
             mvi a,''
             aci 0
             mov b,a
             call put_byte
             ret

show_sp:     call put_byte
             jmp mar_pass

show_1:      call show_spc
             jmp position

control:     mvi b,h'1b
             call put_byte
             mvi b,h'5b
             jmp put_byte

showgrid:    call cls
             lda x_size
             rrc
             ani h'3f
             mov b,a
             mvi a,31
             sub b
             sta centre
             push psw
             mov b,a
             lda x_size
             adi 3
             add b
             call set_pos1
             lxi h,ms_core
             call string
             pop psw
             call set_pos1
             mvi a,h'b
             call setcolor
             lda x_size
             mov h,a
             mvi b,''
             call put_byte
             
sgr_loop:    mvi b,''
             call put_byte
             dcr h
             jnz sgr_loop
             mvi b,''
             call put_byte
             call crlf
             lda centre
             call set_pos1
             mvi l,0

sgs_loop:    mvi b,''
             call put_byte
             mvi a,6
             call setcolor
             mvi h,0

sgt_loop:    call getarray
             ora a
             jz nothing
             cpi '*'
             jz nothing
             cpi ''
             jz d_i_a
             cpi ':'
             jz d_i_a
             cpi 'X'
             jz d_i_a
             cpi ''
             jz d_i_a
             cpi ' '
             jz d_i_a
             mov b,a
             ani h'40
             jnz d_i_a
             mov a,b
             ani h'b0
             cpi h'b0
             jnz nothing
             
d_i_a:       push h
             call show_spc
             pop h
             jmp something

nothing:     push h
             mvi a,h'6
             call setcolor
             pop h
             call tile
             
something:   inr h
             lda x_size
             cmp h
             jnz sgt_loop
             mvi a,h'b
             call setcolor
             mvi b,''
             call put_byte
             call crlf
             lda centre
             call set_pos1
             inr l
             lda y_size
             cmp l
             jnz sgs_loop
             mvi b,''
             call put_byte
             lda x_size
             mov h,a

sgu_loop:    mvi b,''             
             call put_byte
             dcr h
             jnz sgu_loop
             mvi b,''
             call put_byte
             ret


set_pos1:    push psw
             mvi b,h'1b
             call put_byte
             mvi b,h'5b
             call put_byte
             pop psw
             call do_math
             mvi b,'C'
             call put_byte
             ret


do_math3:    lxi b,-10000
             call doc_part
             lhld tmp
             lxi b,-1000
             call doc_part
             lhld tmp
             lxi b,-100
             call doc_part
             lda tmp
             jmp do_math

doc_part:    mvi d,h'ff

dob_loop:    shld tmp
             inr d
             dad b
             jc dob_loop
             mvi a,h'30
             add d
             mov b,a
             jmp put_byte

do_math2:    mvi b,h'ff
             
doa_loop:    mov d,a
             inr b
             sui 100
             jnc doa_loop
             mvi a,'0'
             add b
             cpi '0'
             mov b,a
             cnz put_byte
             mov a,d

do_math:     mvi b,h'ff

spa_loop:    mov d,a
             inr b
             sui h'a
             jnc spa_loop
             mvi a,h'30
             add b
             mov b,a
             call put_byte
             mvi a,h'30
             add d
             mov b,a
             jmp put_byte

crlf:        mvi b,10
             call put_byte
             mvi b,13
             jmp put_byte

setcolor:    mov h,a
             lda oldcolr
             cmp h
             rz
             mvi b,h'1b
             call put_byte
             mvi b,h'5b
             call put_byte
             lda oldcolr
             ani h'18
             xra h
             cnz no_mod
             mov a,h
             sta oldcolr
             ani h'10
             cnz setflash
             mov a,h
             ani h'8
             cnz setbold
             mvi b,'3'
             call put_byte
             mov a,h
             ani h'7
             adi '0'
             mov b,a
             call put_byte
             push h
             lxi h,ms_scend
             call string
             pop h
             ret

no_mod       mvi b,'0'
             jmp sf_cheat

setflash:    mvi b,'5'
             jmp sf_cheat

setbold:     mvi b,'1'
            
sf_cheat:    call put_byte
             mvi b,';'
             jmp put_byte

string:      mov b,m
             mov a,b
             ora a
             rz
             call put_byte
             inx h
             jmp string
             
update:      push psw
             ani 8
             cz turn_it
             pop psw
             ret

illegal:     mov a,d
             cpi 0
             jz gh_loop
             cpi 1
             jz gh_loop
             jmp ill_ret

random:      lhld alpha
             mov a,h
             ani h'60
             rlc 
             rlc       ;bit 6
             push psw
             rlc       ;bit 5 to 0
             ani 1
             mov b,a
             pop psw
             ani 1
             xra b
             rrc
             mov a,l
             ral
             mov l,a
             mov a,h
             ral
             mov h,a
             shld alpha
             ret
 
get_num:     mov d,h

get_num2:    call get_byte
             mov a,b
             cpi 10
             jz try_done
             cpi 13
             jz try_done
             sui h'30
             jc get_num2
             sui h'a
             jnc get_num2
             mov a,b
             ani h'f
             mov b,a
             mov a,h
             rlc
             rlc
             rlc
             rlc
             ani h'f0
             ora b
             mov h,a
             push h
             lxi h,ms_bak2
             call string
             pop h
             mov a,h
             rrc
             rrc
             rrc
             rrc
             ani h'f
             adi h'30
             mov b,a
             call put_byte
             mov a,h
             ani h'f
             adi h'30
             mov b,a
             call put_byte
             jmp get_num2

try_done:    mov a,h
             cmp l
             jnc get_num2
             cmp d
             jc get_num2
             rrc
             rrc
             rrc
             rrc
             ani h'f
             mov d,a
             inr d
             mov a,h
             ani h'f

td_loop:     dcr d
             rz
             adi h'a
             jmp td_loop


sho_ins:     lxi h,ms_ins
             call string
             call get_byte
             xra a
             ret

;HL=x/y coord.
;Acc=byte.

shoarray:    call stoarray
             push h
             call fix_coord
             pop h
             push h
             call show_spc
             pop h
             ret


stoarray:    push h
             push psw
             call sa_add
             pop psw
             mov m,a
             pop h
             ret

getarray:    push h
             call sa_add
             mov a,m
             pop h
             ret

sa_add:      push b
             lda x_size
             mov c,a
             mvi b,0
             mov a,l
             mov e,h
             lxi h,0

sb_loop:     ora a
             jz sc_done
             dad b
             dcr a
             jmp sb_loop

sc_done:     mvi d,0
             dad d
             xchg
             lxi h,field
             dad d
             pop b
             ret
                  
show_spc:    call getarray
             mov l,a
             cpi '*'
             jz do_bomb
             cpi ''   ;240
             jz do_bomb
             cpi ''   ;237
             jz do_bomb
             cpi ':'
             jz flashit
             cpi 'X'
             jz flashit
             cpi ' '
             jz do_spc
             ora a
             jz do_spc
             ani h'40
             jnz do_mark
             mov a,l
             ani h'3f
             mov l,a
             dcr a
             ani h'7
             adi h'8
             cpi h'8
             cz fix_colr
             ani h'f


sso_ret:     push h
             call setcolor
             pop h
             mov b,l
             jmp put_byte

fix_colr:    dcr a
             ret

do_bomb:     mvi a,h'1
             jmp sso_ret

do_mark:     mvi a,h'1
             mvi l,''
             jmp sso_ret

flashit:     mvi a,h'11
             jmp sso_ret


do_spc:      mvi l,' '
             lda oldcolr
             jmp sso_ret


cls:         lxi h,ms_cls
             jmp string

ms_cls:      .db h'1b,"[2J",0

ms_bak2:     .db h'1b,"[2D",0

ms_sizex:    .db h'1b,"[2J",h'1b,"[0,1,33mX-Size? (",h'1b,"[31m10",h'1b
             .db "[33m-",h'1b,"[31m60",h'1b,"[33m): 10",0

ms_sizey:    .db "\n\rY-Size? (",h'1b,"[31m10",h'1b,"[33m-",h'1b,"[31m20"
             .db h'1b,"[33m): 10",0

ms_diff:     .db "\n\rDifficulty? (",h'1b,"[31m1",h'1b,"[33m-",h'1b,"[31m5"
             .db h'1b,"[33m): 01",0

ms_init:     .db h'1b,"[0;1;33;40m"
             .db h'1b,"[2JWelcome to CoreSweeper ",h'1b
             .db "[36m'85",h'1b,"[33m! "
             .db " Instructions? (",h'1b,"[31mY"
             .db h'1b,"[33m/",h'1b,"[31mN",h'1b
             .db "[33m)",0
 
;ms_wait:     .db "\n\rPlease wait while I initalize.\n\r\n\r",0

ms_ins:      .db h'1b,"[2J"
             .db "  ",h'1b,"[33m                       Welcome to" 
             .db " CoreSweeper ",h'1b,"[36m8085",h'1b,"[33m!\n\r\n\r"
             .db "  An evil programmer has filled your core with "
             .db "deadly ",h'1b,"[31mRST 0",h'1b,"[33m's, and it'"
             .db "s your\n\rjob to find them!  Be aware, if you b"
             .db "y chance happen to execute one of the\n\rdeadly" 
             .db " instructions, you'll smash the stack!\n\r\n\r\n\r"
             .db h'1b,"[37mKeys:\n\r----\n\r\n\rG: ",h'1b,"[34"
             .db "m--------- Start program execution (sweep an ar"
             .db "ea).\n\r",h'1b,"[37mM:",h'1b,"[34m --------- Ma"
             .db "rk/ Unmark an address.\n\r",h'1b,"[37mH:",h'1b,"[3"
             .db "4m --------- HLT (back to system).\n\r",h'1b,"["
             .db "37mR:",h'1b,"[34m --------- RST 0 (new game).\n\r"
             .db h'1b,"[37mD:",h'1b,"[34m --------- Hex Dump (red"
             .db "raw screen).\n\r",h'1b,"[37mS:",h'1b,"[34m ----"
             .db "----- ",h'1b,"[5;31mSuperuser",h'1b,"[0;1;34m ("
             .db "'boss' key; press <ESC> to get back)\n\r\n\rSee" 
             .db " ",h'1b,"[31mCS.DOC",h'1b,"[34m for more info!\n\r"
             
ms_press:    .db "\n\r                        Press any key to co"
             .db "ntinue",h'1b,"[33m\0"

ms_plyrs:    .db h'1b,"[1;31m"
             .db "My poor instruction decoder- It can't take this" 
             .db " abuse!\n\r\n\rMake it stop mommy; make it stop"
             .db "!!!!\n\rOh God of Intel, where are you?!?!?!..."
             .db "\n\r\n\r\n\r",h'1b,"[33mSee your mistake?\0"

ms_core:     .db h'1b,"[0;1;33mCoreSweeper",h'1b,"[1B",h'1b,"[9D",h'1b
             .db "[36m8 0 8 5",h'1b,"[3B",h'1b,"[10D",h'1b,"[32m"
             .db " RST 0s:",h'1b,"[2B",h'1b,"[7DMarked:",h'1b,"[2B"
             .db h'1b,"[8D Moves:",h'1b,"[H",h'1b,"[33m\0"

ms_win:      .db h'1b,"[2J",h'1b,"[0;1;37mYou did it!  I can't"
             .db " believe it!!!  Good job!\n\r\n\r",h'1b,"[33m"
             .db "Your score is: ",h'1b,"[5;31m\0"

ms_again:    .db h'1b,"[0;1;33m\n\r\n\rPlay again?\0"

ms_thank:    .db "\n\r",h'1b,"[0;1;33m",h'1b,"[2JThanks for playing CoreS"
             .db "weeper ",h'1b
             .db "[36m8085",h'1b,"[33m!\n\r\n\rCoreSweeper was brought to"
             .db " you by the letter",h'1b,"[34m \0"

ms_than1:    .db h'1b,"[33m and the number ",h'1b,"[34m\0"
             
ms_than2:    .db h'1b,"[33m.\n\r\n\rWe now return you to your"
             .db " monitor, already in progress.\n\r\n\r"
             .db h'1b,"[0,37m\0"

ms_sure:     .db "Are you sure?\0"

ms_wait:     .db h'1b,"[33C",h'1b,"[33m\n\r\n\rThinking...",h'1b,"[37m\0"

ms_scend:    .db "m",0 
 
  
;get_byte:      in h'01
;               ani h'01
;               jz get_byte
;               in h'03
;               mov b,a
;               ret
;
;put_byte:      in h'01
;               ani h'04
;               jz put_byte
;               mov a,b
;               out h'03
;               ret
;

;get_byte:    rim                    ; Wait for a start bit
;             ani h'80               ; Strip all but Strt bit
;             jnz get_byte           ; If not clear, keep waiting
;             push d                 ; Save the DE rp
;             mvi c,h'1c             ; Wait 1 bit-time
;
;rl1:         dcr c                  ; Time- waster
;             jnz rl1                ; Done waiting?
;             rim                    ; Get a serial bit (Note that it's inv.)
;             rlc                    ; Is the byte > 128?
;             rc                     ; If so, quit
;             mvi d,8                ; Setup for 8 bits
;             mvi b,0                ; Zero output byte
;             sub a                  ; clear the Acc.

;rl2:         mvi c,h'3a             ; Set C to bit-time
;
;rl3:         dcr c                  ; Time- waster
;             jnz rl3                ; Done wasting time?
;             rim                    ; Get serial bit
;             ani h'80               ; Strip all but the bit
;             ora b                  ; Put the bit in
;             rar                    ;  the B reg.
;             mov b,a                ; after rotating it.
;             dcr d                  ; Last bit?
;             jnz rl2                ; If not, get another bit
;             ral                    ; Otherwise, re-adjust B reg, because 
;             mov b,a                ;  we rotated one too many! :-)
;             mvi c,h'3a             ; Wait for the stop bit before quitting
;
;rl4:         dcr c                  ; Time- waster
;             jnz rl4                ; Done wasting time?
;             mvi c,1                ; Set C for 'got it O.K.!'
;             pop d                  ; Get saved DE rp
;             ret                    ; Return, after a job well done
;
;put_byte:    push d                 ; Save the DE rp
;             mvi d,8                ; How many bit to send out
;             mvi a,h'40             ; SIM mask
;             sim                    ; Set IM, send start bit
;             mvi c,h'3a             ; How long for SB?
;
;rl5:         dcr c                  ; Time- waster
;             jnz rl5                ; Enough time?
;
;rl6:         mov a,b                ; Get a bit from
;             rrc                    ;  the B
;             mov b,a                ; register by rotating
;             ani h'80               ; Strip off lower 7 bits
;             ori h'40               ; Set SOD enable
;             sim                    ; Set the IM
;             mvi c,h'3a             ; Set up ctr for 1 bit time
;
;rl7:         dcr c                  ; Time- waster
;             jnz rl7                ; Enough?
;             dcr d                  ; Dcr bit counter
;             jnz rl6                ; All 8 bits?  If not, do it again
;             mvi a,h'c0             ; Set SID for a stop bit
;             sim                    ; Set IM
;             mvi c,h'77             ; Set for 2 bit lengths
;
;rl8:         dcr c                  ; Time- waster
;             jnz rl8                ; Done?
;             mvi a,h'8d             ; Finally, re- set SIM
;             sim                    ; Do it
;             pop d                  ; Get DE reg that was saved
;             ret                    ; Return
;
 
get_byte:      in h'01
               ani h'01
               jz get_byte
               in h'03
               mov b,a
               ret

put_byte:      in h'01
               ani h'04
               jz put_byte
               mov a,b
               out h'03
               ret


 .org h'c000

y_size:      .rs 1 
x_size:      .rs 1
y_plyr:      .rs 1
x_plyr:      .rs 1
diff:        .rs 1
mines:       .rs 1
alpha:       .rs 1
beta:        .rs 1
mctr:        .rs 1 
oldcolr:     .rs 1 
centre:      .rs 1
marks:       .rs 1
bottom:      .rs 1 
tmp:         .rs 2
moves:       .rs 2
field:       .rs 1200
 
 
 .end














